ex:- input(Mess),
     composer(Mess).

st:- clean_all,spy(traiter).



% REPRESENTATION CONCEPTUELLE


% Les objets de l'univers

univers([a1,bar1,p1,m1,v1,c1,alg1,par1,rea1,lpa1]).




% Les proprietes non temporelles des objets

desc(a1,[onto(avion),connu]).
desc(lpa1,[onto(liaison)]).
desc(p1,[onto(ville),id('Paris')]).
desc(bar1,[onto(ville),id('Barcelone')]).
desc(rea1,[onto(reacteur),att(gauche),connu]).
desc(m1,[onto(mer),connu]).
desc(v1,[onto(voyant)]).
desc(c1,[onto(cote),connu]).
desc(alg1,[onto(pays),id('Algrie')]).


% Les proprietes temporelles des objets

les_relations([

% Relations de la donnee:
               incldans(o1,ct1),
               avant(ct1,n),
               avant(o1,n),

               equ(o2,ct3),
               avant(o2,n),

               avant(o3,n),
               avant(o4,n),
               avant(o5,n),
               avant(o6,n),
               avant(o7,n),
               avant(o8,n),
               avant(o9,n),
               avant(o10,n),
               avant(o11,n),
               avant(o12,n),

               avant(o6,o5),

               avant(o6,o7),
               avant(o7,o5)

              ]).
 

% Les objets temporels

occurrence(o1,[processus(effectuer),acteur(a1),but(lpa1)]).
occurrence(o2,[processus(quitter),acteur(a1),but(p1)]).
occurrence(o3,[processus(survoler),acteur(a1),but(bar1)]).
occurrence(o4,[processus(fonctionner),acteur(rea1)]).
occurrence(o5,[processus(clignoter),acteur(v1)]).
occurrence(o6,[processus(allumer),acteur(v1),but(v1)]).
occurrence(o7,[processus(eteindre),acteur(v1),but(v1)]).
occurrence(o8,[processus(survoler),acteur(a1),but(m1)]).
occurrence(o9,[processus(atteindre),acteur(a1),but(c1)]).
occurrence(o10,[processus(survoler),acteur(a1),but(alg1)]).
occurrence(o11,[processus(arriver),acteur(a1)]).
occurrence(o12,[processus(exploser),acteur(rea1)]).

constante(n,heure1(17475937)).
constante(ct0,jour1(728165)).
constante(ct1,jour1(728164)).
constante(ct2,minute1(0000)).
constante(ct3,apres(constante(ct2),120)).
constante(ct4,minute(0000)).
constante(ct5,duree(minute(35))).
constante(ct6,position(cadre(constante(ct1),minute,horaire),[10,50])).
constante(ct7,position(cadre(constante(ct1),minute,horaire),[11,30])).
constante(ct10,apres(occurrence(o8),indefini)).
constante(ct11,termpar(constante(ct6))).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% REPRESENTATION SEMANTIQUE


% Le contexte


contexte(_,[]).

% L'input



input([
        [message === evenement(o1),
         enon    === constante(n),
         ref     === nil,
         persp   === constante(n),
         focus   === a1,
	 loc     === incldans([ct1,jour,3],[ct2,mois,avril])],

	[message === evenement(o2),
         contexte===[onto===[a1]],
         enon    === constante(n),
	 ref     === occurrence(o1),
	 persp   === constante(n),
	 loc     === incldans([ct3,minute,0],[ct4,heure,8]),
	 focus   === a1],

	[message === situation_ouverte(o4),
         contexte===[onto===[a1]],
         enon    === constante(n),
	 ref     === occurrence(o2),
	 persp   === constante(n),
	 loc     === occurrence(o3),
	 focus   === rea1],

	[message === evenement(o5),
         enon    === constante(n),
	 ref     === occurrence(o3),
	 persp   === constante(n),
	 loc     === incldans([ct3,minute,15],[ct4,heure,10]),
	 focus   === v1],

	[message === evenement(o6),
         enon    === constante(n),
         contexte===[onto===[v1]],
	 ref     === occurrence(o5),
	 persp   === occurrence(o5),
	 loc     === avant([ct8,_,_],[o5,_,_],indefini),
	 focus   === v1],

	[message === evenement(o7),
         enon    === constante(n),
         contexte===[onto===[v1]],
	 ref     === occurrence(o6),
	 persp   === occurrence(o5),
	 loc     === apres([ct9,_,_],[o6,_,_],indefini),
	 focus   === v1],

	[message === evenement(o8),
         enon    === constante(n),
	 ref     === occurrence(o5),
	 persp   === constante(n),
	 loc     === duree(35,minute),
	 focus   === a1],

	[message === evenement(o9),
         enon    === constante(n),
	 ref     === occurrence(o8),
	 persp   === constante(n),
	 loc     === apres([ct10,_,_],[o8,_,_],indefini),
	 focus   === a1],

	[message === evenement(o10),
         enon    === constante(n),
	 ref     === occurrence(o9),
	 persp   === constante(n),
	 loc     === termpar([ct11,_,_],
                            incldans([ct6,minute,50],[ct4,heure,10])),
	 focus   === a1],

	[message === situation_resultante(o11),
         enon    === constante(n),
	 ref     === occurrence(o10),
	 persp   === constante(n),
	 loc     === incldans([ct7,minute,30],[ct23,heure,11]),
	 focus   === a1],

	[message === evenement(o12),
         enon    === constante(n),
	 ref     === constante(ct7),
	 persp   === constante(n),
	 loc     === [ct7,_,_],
	 focus   === rea1]
         
     ]).
