% adjectifs

decliner(adjectif(Rad,cat(numeral,cardinal),_,_),Rad).



% articles

decliner(article(un,masculin,singulier),un).
decliner(article(un,feminin,singulier),une).
decliner(article(un,_,pluriel),des).

decliner(article(le,masculin,singulier),le).
decliner(article(le,feminin,singulier),la).
decliner(article(le,_,pluriel),les).

decliner(article(ce,masculin,singulier),ce).
decliner(article(ce,feminin,singulier),cette).
decliner(article(ce,_,pluriel),ces).


% noms





decliner(nom(Rad,_,_),Rad):-
	lexique(nom,Rad,_,Info),
	member(accord_nombre===invariable,Info).


decliner(nom(Nom,_,pluriel),Nom):-
        terminaison_nom(Nom,[o,i,s]).
        
decliner(nom(Rad,_,pluriel),Forme):-
	nom(Rad,R),
	ajouter_fin(s,R,Rs),
	nom(Forme,Rs).



terminaison_nom(N,T):-
        reverse(T,T1),
	nom(N,N1),
        append(T1,_,T2),
	reverse(N1,T2).


% pronoms


decliner(pronom(personnel,conjoint,subjectif,_,1,_,singulier),je).
decliner(pronom(personnel,conjoint,objectif,_,1,_,singulier),me).
decliner(pronom(personnel,conjoint,reflexif,_,1,_,singulier),me).
decliner(pronom(personnel,disjoint,_,_,1,_,singulier),moi).

decliner(pronom(personnel,conjoint,subjectif,_,2,_,singulier),tu).
decliner(pronom(personnel,conjoint,objectif,_,2,_,singulier),te).
decliner(pronom(personnel,conjoint,reflexif,_,2,_,singulier),te).
decliner(pronom(personnel,disjoint,_,_,2,_,singulier),toi).

decliner(pronom(personnel,conjoint,subjectif,_,3,masculin,singulier),il).
decliner(pronom(personnel,conjoint,subjectif,_,3,feminin,singulier),elle).
decliner(pronom(personnel,conjoint,objectif,direct,3,masculin,singulier),le).
decliner(pronom(personnel,conjoint,objectif,direct,3,feminin,singulier),la).
decliner(pronom(personnel,conjoint,objectif,indirect,3,_,singulier),lui).
decliner(pronom(personnel,conjoint,reflexif,_,3,_,singulier),se).
decliner(pronom(personnel,disjoint,subjectif,_,3,masculin,singulier),lui).
decliner(pronom(personnel,disjoint,subjectif,_,3,feminin,singulier),elle).
decliner(pronom(personnel,disjoint,objectif,direct,3,masculin,singulier),lui).
decliner(pronom(personnel,disjoint,objectif,direct,3,feminin,singulier),elle).
decliner(pronom(personnel,disjoint,objectif,indirect,3,masculin,singulier),lui).
decliner(pronom(personnel,disjoint,objectif,indirect,3,feminin,singulier),elle).
decliner(pronom(personnel,disjoint,reflexif,_,3,_,singulier),soi).

decliner(pronom(personnel,_,_,_,1,_,pluriel),nous).

decliner(pronom(personnel,_,_,_,2,_,pluriel),vous).

decliner(pronom(personnel,conjoint,subjectif,_,3,masculin,pluriel),ils).
decliner(pronom(personnel,conjoint,subjectif,_,3,feminin,pluriel),elles).
decliner(pronom(personnel,conjoint,objectif,direct,3,_,pluriel),les).
decliner(pronom(personnel,conjoint,objectif,indirect,3,_,pluriel),leur).
decliner(pronom(personnel,conjoint,reflexif,_,3,_,pluriel),se).
decliner(pronom(personnel,disjoint,subjectif,_,3,masculin,pluriel),eux).
decliner(pronom(personnel,disjoint,subjectif,_,3,feminin,pluriel),elles).
decliner(pronom(personnel,disjoint,objectif,direct,3,masculin,pluriel),eux).
decliner(pronom(personnel,disjoint,objectif,direct,3,feminin,pluriel),elles).
decliner(pronom(personnel,disjoint,objectif,indirect,3,masculin,pluriel),eux).
decliner(pronom(personnel,disjoint,objectif,indirect,3,feminin,pluriel),elles).
decliner(pronom(personnel,disjoint,reflexif,_,3,_,pluriel),eux).


%% CONJUGUAISON DES VERBES

% Definit les predicats suivants:
%
%             aux_etre/1
%             changerad/6
%             cherche/3
%             conj2/8
%             conjugue/8
%             decliner/2
%             doitchanger/4
%             pluriel/2
%             quelmodele/3
%             trouveconj/4
%             trouvemodele/2
%             trouvepart/4
%             trouverad/3
    

decliner(verbe(Infinitif,participe,Temps,_,Nombre,Genre),Forme) :-
   trouvemodele(Infinitif,Modele,Groupe),
   conjugue_part(Infinitif,Temps,Groupe,Modele,Nombre,Genre,Forme).

decliner(verbe(Infinitif,Mode,Temps,Pers,Nombre,_),Forme) :-
   trouvemodele(Infinitif,Modele,Groupe),
   conjugue(Infinitif,Groupe,Modele,Pers,Nombre,Mode,Temps,Forme),!.

% Verbe avoir

% 1
conjugue(avoir,_,_,1,singulier,indicatif,present,ai).
conjugue(avoir,_,_,2,singulier,indicatif,present,as).
conjugue(avoir,_,_,3,singulier,indicatif,present,a).
conjugue(avoir,_,_,1,pluriel,indicatif,present,avons).
conjugue(avoir,_,_,2,pluriel,indicatif,present,avez).
conjugue(avoir,_,_,3,pluriel,indicatif,present,ont).

% 7
conjugue(avoir,_,_,1,singulier,subjonctif,present,aie).
conjugue(avoir,_,_,2,singulier,subjonctif,present,aies).
conjugue(avoir,_,_,3,singulier,subjonctif,present,aie).
conjugue(avoir,_,_,1,pluriel,subjonctif,present,ayons).
conjugue(avoir,_,_,2,pluriel,subjonctif,present,ayez).
conjugue(avoir,_,_,3,pluriel,subjonctif,present,aient).

% 13
conjugue(avoir,_,_,2,singulier,imperatif,present,aie).
conjugue(avoir,_,_,2,pluriel,imperatif,present,ayons).
conjugue(avoir,_,_,2,pluriel,imperatif,present,ayez).

%16
conjugue(avoir,_,_,1,singulier,indicatif,passe,eus).
conjugue(avoir,_,_,2,singulier,indicatif,passe,eus).
conjugue(avoir,_,_,3,singulier,indicatif,passe,eut).
conjugue(avoir,_,_,1,pluriel,indicatif,passe,'eumes').
conjugue(avoir,_,_,2,pluriel,indicatif,passe,'eutes').
conjugue(avoir,_,_,3,pluriel,indicatif,passe,'eurent').

%22
conjugue(avoir,_,_,Pers,Nombre,indicatif,imparfait,Forme) :-
	conj2(av,'',1,Pers,Nombre,indicatif,imparfait,Forme).
conjugue(avoir,_,_,Pers,Nombre,indicatif,futur,Forme) :-
   conj2(au,'',3,Pers,Nombre,indicatif,futur,Forme).

%24
conjugue(_,_,etre,1,singulier,indicatif,present,suis).
conjugue(_,_,etre,2,singulier,indicatif,present,es).
conjugue(_,_,etre,3,singulier,indicatif,present,est).
conjugue(_,_,etre,1,pluriel,indicatif,present,sommes).
conjugue(_,_,etre,2,pluriel,indicatif,present,etes).
conjugue(_,_,etre,3,pluriel,indicatif,present,sont).

%30
conjugue(_,_,etre,1,singulier,subjonctif,present,soie).
conjugue(_,_,etre,2,singulier,subjonctif,present,sois).
conjugue(_,_,etre,3,singulier,subjonctif,present,soit).
conjugue(_,_,etre,1,pluriel,subjonctif,present,soyons).
conjugue(_,_,etre,2,pluriel,subjonctif,present,soyez).
conjugue(_,_,etre,3,pluriel,subjonctif,present,soient).

%36
conjugue(_,_,etre,2,singulier,imperatif,present,sois).
conjugue(_,_,etre,2,pluriel,imperatif,present,soyons).
conjugue(_,_,etre,2,pluriel,imperatif,present,soyez).

%39
conjugue(_,_,etre,Pers,Nombre,indicatif,imparfait,Forme) :-
   conj2('t','',1,Pers,Nombre,indicatif,imparfait,Forme).
conjugue(_,_,etre,Pers,Nombre,indicatif,futur,Forme) :-
   conj2(se,'',3,Pers,Nombre,indicatif,futur,Forme).

%41
conjugue(aller,_,_,1,singulier,indicatif,present,vais).
conjugue(aller,_,_,2,singulier,indicatif,present,vas).
conjugue(aller,_,_,3,singulier,indicatif,present,va).
conjugue(aller,_,_,1,pluriel,indicatif,present,allons).
conjugue(aller,_,_,2,pluriel,indicatif,present,allez).
conjugue(aller,_,_,3,pluriel,indicatif,present,vont).

%47
conjugue(aller,_,_,Pers,Nombre,indicatif,imparfait,Forme):-
   conj2(all,'',1,Pers,Nombre,indicatif,imparfait,Forme).
conjugue(aller,_,_,Pers,Nombre,indicatif,futur,Forme) :-
   conj2('','',2,Pers,Nombre,indicatif,futur,Forme).



% INFINITIF

%49
conjugue(Infinitif,_,_,_,_,infinitif,present,Infinitif).

%50
conjugue(Infinitif,_,_,_,_,infinitif,passe,['tre',Participe]):-
        aux_etre(AuxEtre),
        member(Infinitif,AuxEtre),
	trouvepart(passe,_,_,Infinitif,Participe).
conjugue(Infinitif,_,_,_,_,infinitif,passe,[avoir,Participe]):-
	trouvepart(passe,_,_,Infinitif,Participe).

	
	
 % IMPERATIF
%52
conjugue(Infinitif,Groupe,Modele,2,singulier,imperatif,_,Forme):-
	conjugue(Infinitif,Groupe,Modele,1,singulier,indicatif,present,Forme).
conjugue(Infinitif,Groupe,Modele,P,pluriel,imperatif,_,Forme):-
	conjugue(Infinitif,Groupe,Modele,P,pluriel,indicatif,present,Forme).

% PARTICIPE PASSE
%54
conjugue_part(Infinitif,passe,Groupe,Modele,Nombre,Genre,Forme):-
	trouvepart(passe,Groupe,Modele,Infinitif,Part),
	accorder_part(Part,Genre,Nombre,Forme).


% TEMPS SIMPLES

%%%%%%%%%%%%%%% VERBES DU PREMIER GROUPE %%%%%%%%%%%%%%%%

% Verbes en -GER
%55
conjugue(Infinitif,1,manger,Pers,Nombre,Mode,Temps,Forme) :-
   conj2(Infinitif,er,4,Pers,Nombre,Mode,Temps,Forme).

% Verbes en -YER
%56 
conjugue(Infinitif,1,payer,Pers,Nombre,Mode,Temps,Forme) :-
   conj2(Infinitif,yer,5,Pers,Nombre,Mode,Temps,Forme).

% Verbes en -ELER qui doublent le L
%57
conjugue(Infinitif,1,eler1,Pers,Nombre,Mode,Temps,Forme):-
   conj2(Infinitif,er,6,Pers,Nombre,Mode,Temps,Forme).

%Verbes en _ETER qui doublent le T
conjugue(Infinitif,1,eter1,Pers,Nombre,Mode,Temps,Forme) :-
   conj2(Infinitif,er,8,Pers,Nombre,Mode,Temps,Forme).

% Verbes en -ELER ou -ETER qui ne doublent pas le L
conjugue(Infinitif,1,modeler,Pers,Nombre,Mode,Temps,Forme):-
   changerad(Infinitif,Pers,Nombre,Mode,Temps,Rad),
   conj2(Rad,'',1,Pers,Nombre,Mode,Temps,Forme).

% Verbes reguliers du premier groupe
conjugue(Infinitif,1,aimer,Pers,Nombre,Mode,Temps,Forme):-
   conj2(Infinitif,er,1,Pers,Nombre,Mode,Temps,Forme).




%%%%%%%%%%%%%%%% VERBES DU DEUXIEME GROUPE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% verbes reguliers du deuxieme groupe
conjugue(Infinitif,2,finir,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,ir,2,Pers,Nombre,Mode,Temps,Forme).




%%%%%%%%%%%%%%%% VERBES DU TROISIEME GROUPE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%


conjugue(Infinitif,3,venir,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,enir,9,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,courir,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,ir,10,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,ouvrir,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,ir,11,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,servir,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,vir,12,Pers,Nombre,Mode,Temps,Forme).


conjugue(Infinitif,3,faire,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,faire,20,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,devoir,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,devoir,21,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,pouvoir,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,pouvoir,22,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,vouloir,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,vouloir,14,Pers,Nombre,Mode,Temps,Forme).
    
conjugue(Infinitif,3,rendre,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,dre,23,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,peindre,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,ndre,15,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,mettre,Pers,Nombre,Mode,Temps,Forme):-
        conj2(Infinitif,ettre,24,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,suffire,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,re,25,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,falloir,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,lloir,26,Pers,Nombre,Mode,Temps,Forme).

conjugue(Infinitif,3,suivre,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,vre,27,Pers,Nombre,Mode,Temps,Forme).
conjugue(Infinitif,3,lire,Pers,Nombre,Mode,Temps,Forme):-
    conj2(Infinitif,re,13,Pers,Nombre,Mode,Temps,Forme).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% CONJ2 touve la forme finale du verbe conjugu/e pour les temps simples.
conj2(Infinitif,Finale,Type,Pers,Nombre,Mode,Temps,Forme):-
    member(Temps,[present,imparfait,futur]),
    trouverad(Infinitif,Finale,Radical),
    nom(Radical,L_radical),
    terminaison(Type,L_term,Pers,Nombre,Mode,Temps),
    append(L_radical,L_term,L_Forme),
    nom(Forme,L_Forme).  




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



% TEMPS COMPOSES



% Passe compose
conjugue(Infinitif,Groupe,Modele,Pers,singulier,indicatif,passcomp,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,singulier,indicatif,present,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,pluriel,indicatif,passcomp,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,pluriel,indicatif,present,Auxiliaire),
    pluriel(Participe,Part_pluriel),
    unit(Auxiliaire,Part_pluriel,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,Nombre,indicatif,passcomp,Forme):-
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(avoir,_,_,Pers,Nombre,indicatif,present,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).



% Passe surcompose
conjugue(Infinitif,Groupe,Modele,Pers,singulier,indicatif,surcompose,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,singulier,indicatif,passcomp,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,pluriel,indicatif,surcompose,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,pluriel,indicatif,passcomp,Auxiliaire),
    pluriel(Participe,Part_pluriel),
    unit(Auxiliaire,Part_pluriel,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,Nombre,indicatif,surcompose,Forme):-
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(avoir,_,_,Pers,Nombre,indicatif,passcomp,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).


% Futur anterieur
conjugue(Infinitif,Groupe,Modele,Pers,singulier,indicatif,futurant,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,singulier,indicatif,futur,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,pluriel,indicatif,futurant,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,pluriel,indicatif,futur,Auxiliaire),
    pluriel(Participe,Part_pluriel),
    unit(Auxiliaire,Part_pluriel,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,Nombre,indicatif,futurant,Forme):-
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(avoir,_,_,Pers,Nombre,indicatif,futur,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).


% Plus-que-parfait
conjugue(Infinitif,Groupe,Modele,Pers,singulier,indicatif,plusqueparf,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,singulier,indicatif,imparfait,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,pluriel,indicatif,plusqueparf,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,pluriel,indicatif,imparfait,Auxiliaire),
    pluriel(Participe,Part_pluriel),
    unit(Auxiliaire,Part_pluriel,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,Nombre,indicatif,plusqueparf,Forme):-
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(avoir,_,_,Pers,Nombre,indicatif,imparfait,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).


% Subjonctif passe
conjugue(Infinitif,Groupe,Modele,Pers,singulier,subjonctif,passe,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,singulier,subjonctif,present,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,pluriel,subjonctif,passe,Forme) :-
    aux_etre(AuxEtre),
    member(Infinitif,AuxEtre),
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(_,_,etre,Pers,pluriel,subjonctif,present,Auxiliaire),
    pluriel(Participe,Part_pluriel),
    unit(Auxiliaire,Part_pluriel,Forme).
conjugue(Infinitif,Groupe,Modele,Pers,Nombre,subjonctif,passe,Forme):-
    trouvepart(passe,Groupe,Modele,Infinitif,Participe),
    conjugue(avoir,_,_,Pers,Nombre,subjonctif,present,Auxiliaire),
    unit(Auxiliaire,Participe,Forme).




% utilitaires

%liste des verbes qui se conjuguent avec l'auxiliaire "etre"
aux_etre([aller, arriver, 'dcder', devenir, 'choir', 'clore', 
          entrer, mourir, 'natre', partir, repartir, rentrer, rester,
          retourner, sortir, tomber, venir, revenir,
	  parvenir, survenir]).


pluriel(Mot,Motpluriel) :-
    nom(Mot,M),
    append(M,[s],Mp),
    nom(Motpluriel,Mp).

trouverad(Infinitif,Finale,Radical) :-
    nom(Infinitif,L_inf),
    nom(Finale,L_finale),
    append(L_radical,L_finale,L_inf),
    nom(Radical,L_radical).




% IDENTIFICATION DE L'ORTHOGRAPHE DU PARTICIPE


trouvepart(passe,1,_,Inf,Part):-
    nom(Inf,Inf2),
    renverse(Inf2,[r,e|Reste]),
    renverse([|Reste],Part2),
    nom(Part,Part2).




trouvepart(passe,3,ouvrir,Inf,Part):-
    nom(Inf,Inf2),
    renverse(Inf2,[r,i,r|Reste]),
    renverse([t,r,e|Reste],Part2),
    nom(Part,Part2).

trouvepart(passe,2,Modele,Inf,Part):-
    member(Modele,[venir,courir]),
    nom(Inf,Inf2),
    renverse(Inf2,[r,i|Reste]),
    renverse([u|Reste],Part2),
    nom(Part,Part2).

trouvepart(passe,2,_,Inf,Part):-
    nom(Inf,Inf2),
    renverse(Inf2,[r|Reste]),
    renverse(Reste,Part2),
    nom(Part,Part2).


trouvepart(passe,3,avoir,avoir,eu).
trouvepart(passe,3,etre,avoir,'t').

trouvepart(passe,3,devoir,Inf,Part):-
    nom(Inf,Inf2),
    renverse(Inf2,[r,i,o,v,e|Reste]),
    renverse([|Reste],Part2),
    nom(Part,Part2).
   
trouvepart(passe,3,_,pouvoir,pu).
trouvepart(passe,3,_,vouloir,voulu).
trouvepart(passe,3,faire,Inf,Part):-
    nom(Inf,Inf2),
    renverse(Inf2,[e,r|Reste]),
    renverse([t|Reste],Part2),
    nom(Part,Part2).

trouvepart(passe,3,suffire,Inf,Part):-
    nom(Inf,Inf2),
    renverse(Inf2,[e,r|Reste]),
    renverse(Reste,Part2),
    nom(Part,Part2).
 
trouvepart(passe,3,rendre,Inf,Part):-
    nom(Inf,Inf2),
    renverse(Inf2,[e,r|Reste]),
    renverse([u|Reste],Part2),
    nom(Part,Part2).

trouvepart(passe,3,peindre,Inf,Part):-
    nom(Inf,Inf2),
    renverse(Inf2,[e,r,d|Reste]),
    renverse([t|Reste],Part2),
    nom(Part,Part2).

trouvepart(passe,3,mettre,Inf,Part):-
    nom(Inf,Inf2),
    renverse(Inf2,[e,r,t,t,e|Reste]),
    renverse([s,i|Reste],Part2),
    nom(Part,Part2).



accorder_part(Part,masculin,pluriel,Acc):-
    nom(Part,P),
    ajouter_fin(s,P,Pacc),
    nom(Acc,Pacc).
accorder_part(Part,feminin,singulier,Acc):-
    nom(Part,P),
    ajouter_fin(e,P,Pacc),
    nom(Acc,Pacc).
accorder_part(Part,feminin,pluriel,Acc):-
    nom(Part,P),
    append(P,[e,s],Pacc),
    nom(Acc,Pacc).
accorder_part(Part,_,_,Part).



cherche(X,Cle,[[Cle,X]|_]).
cherche(X,Cle,[[Clediff,_]|Reste]):-
    Cle \== Clediff,
    cherche(X,Cle,Reste).
   

changerad(Inf,Pers,Nombre,Mode,Temps,Nouv_rad) :-
   doitchanger(Pers,Nombre,Mode,Temps),
   nom(Inf,L_inf),
   renverse(L_inf,[r,e,X,e|Rad_Renv]),
   renverse([X,|Rad_Renv],L_rad),
   nom(Nouv_rad,L_rad).
changerad(Inf,_,_,_,_,Nouv_rad) :-
   trouverad(Inf,er,Nouv_rad).

doitchanger(_,_,_,futur).
doitchanger(_,singulier,indicatif,present).
doitchanger(3,pluriel,indicatif,present).







trouvemodele(pouvoir,pouvoir,3).
trouvemodele(Verbe,devoir,3):-
	member(Verbe,[devoir,redevoir]).
trouvemodele(Verbe,ouvrir,3):-
	member(Verbe,[couvrir,ouvrir,offrir,souffrir]).

trouvemodele(Infinitif,Modele,Groupe):-
    nom(Infinitif,Inf),
    renverse(Inf,Fni),
    quelmodele(Infinitif,Fni,Modele,Groupe).

quelmodele(_,[r,i,o,v,a],avoir,3).
quelmodele(_,[e,r,t,],etre,3).
quelmodele(_,[r,e,l,l,a],aller,3).
quelmodele(_,[r,e,g|_],manger,1).
quelmodele(_,[r,e,s,e|_],modeler,1).
quelmodele(_,[r,e,c,e|_],modeler,1).
quelmodele(_,[r,e,m,e|_],modeler,1).
quelmodele(_,[r,e,n,e|_],modeler,1).
quelmodele(_,[r,e,p,e|_],modeler,1).
quelmodele(_,[r,e,r,e|_],modeler,1).
quelmodele(_,[r,e,v,e|_],modeler,1).
quelmodele(Inf,[r,e,l,e|_],modeler,1):-
   member(Inf,[celer,'dceler','receler',geler,peler,
                 ciseler,'dmanteler','carteler','dgeler',
                 congeler,surgeler,marteler,modeler]).
quelmodele(_,[r,e,l,e|_],eler1,1).
quelmodele(Inf,[r,e,t,e|_],modeler,1) :-
   member(Inf,['complter',acheter,racheter,fureter,haleter,
                  begueter,corseter,fileter,crocheter]).
quelmodele(_,[r,e,t,e|_],eter1,1).
quelmodele(_,[r,e,y|_],payer,1).   
quelmodele(_,[r,e|_],aimer,1).

quelmodele(_,[r,i,n,e|_],venir,3).
quelmodele(_,[r,i,v,r,e,s],servir,3).
quelmodele(_,[r,i,r,u,o,c|_],courir,3).
quelmodele(_,[r,i,r,v,u,o|_],ouvrir,3).
quelmodele(_,[r,i,o,l,u,o,v],vouloir,3).
quelmodele(_,[r,i,o,l,l,a,f],falloir,3).
quelmodele(_,[r,i|_],finir,2).

quelmodele(_,[e,r,i,a,f|_],faire,3).

quelmodele(_,[e,r,i,f,f,u,s],suffire,3).
quelmodele(_,[e,r,i,l|_],lire,3).

quelmodele(_,[e,r,v,i,u,s|_],suivre,3).
quelmodele(_,[e,r,i,l|_],lire,3).
quelmodele(_,[e,r,d,n,e,r,p|_],prendre,3).
quelmodele(_,[e,r,d,n,e|_],rendre,3).
quelmodele(_,[e,r,d,n,a|_],rendre,3).
quelmodele(_,[e,r,d,n,i|_],peindre,3).
quelmodele(_,[e,r,d,n,o|_],rendre,3).
quelmodele(_,[e,r,d,r,e|_],rendre,3).
quelmodele(_,[e,r,d,r,o|_],rendre,3).
quelmodele(_,[e,r,t,t,e|_],mettre,3).
