
debut(entree).
systeme(constituant,[proposition,nominal,nom,pronom,article,verbal,verbe,
                     adverbial,preposition,adverbe,adjectif],proposition).
suite(debut,entree,constituant).

realiser(debut,entree).






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                   Proposition                           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


systeme(type_prop,[complete,partielle_nominale,partielle_adverbiale],complete).
systeme(niveau_prop,[primaire,secondaire],primaire).
systeme(mode_prop,[commande,enonce,intensionnel],enonce).
systeme(processus,[materiel,mental,relationnel,evolutif],erreur).
systeme(voix,[active,passive],erreur).
systeme(adjoint_secondaire,[oui,non],non).
systeme(extension_active,[explicite,implicite],erreur).
systeme(reflexivite,[reflexif,non_reflexif],non_reflexif).
systeme(extension_passive,[explicite,implicite],erreur).
systeme(aspect,[situation,evenement],erreur).
systeme(type_sit,[resultante,ouverte],erreur).
systeme(localisation,[passe,present,futur,atemporelle],erreur).
systeme(circ_temporelle,[oui,non],non).
systeme(circ_temp_thematise,[oui,non],oui).
systeme(reference_acteur,[anaphorique,non_anaphorique],non_anaphorique).
systeme(reference_but,[anaphorique,non_anaphorique],non_anaphorique).


suite(constituant,proposition,type_prop).
suite(type_prop,complete,conj([niveau_prop, mode_prop,processus,voix,
      aspect,localisation,circ_temporelle])).
suite(type_prop,_,fin).
suite(niveau_prop,_,fin).
suite(mode_prop,_,fin).
suite(processus,_,fin).
suite(voix,active,conj([adjoint_secondaire,extension_active])).
suite(voix,passive,extension_passive).
suite(extension_active,explicite,reflexivite).
suite(extension_active,implicite,reference_acteur).
suite(adjoint_secondaire,_,fin).
suite(reflexivite,reflexif,fin).
suite(reflexivite,non_reflexif,conj([reference_acteur,reference_but])).
suite(extension_passive,explicite,conj([reference_acteur,reference_but])).
suite(extension_passive,implicite,reference_but).
suite(aspect,situation,type_sit).
suite(aspect,evenement,fin).
suite(type_sit,_,fin).
suite(localisation,_,fin).
suite(circ_temporelle,oui,circ_temp_thematise).
suite(circ_temporelle,non,fin).
suite(circ_temp_thematise,_,fin).
suite(reference_acteur,_,fin).
suite(reference_but,_,fin).



realiser(constituant,proposition).

realiser(type_prop,complete):-
        inclure(theme),
	inclure(processus),
	creer(predicat),
	conflater(predicat,processus),
	preselect(predicat,[constituant,verbal]),
	creer(ponctuation),
	attribuer(ponctuation,lex,'.'),
	ordre([...,ponctuation]).
realiser(type_prop,partielle_nominale):-
	creer(objet_designe),
        val_sem(constituant,X),
	attribuer_semantique(objet_designe,X),
        ordre([objet_designe]),
	preselect(objet_designe,[constituant,nominal]).
realiser(type_prop,partielle_adverbiale):-
	creer(objet_designe),
        creer(circ_temp),
        conflater(objet_designe,circ_temp),
        val_sem(constituant,X),
	attribuer_semantique(objet_designe,X),
        ordre([objet_designe]),
	preselect(objet_designe,[constituant,adverbial]),
        preselect(objet_designe,[type_adverbial,temporel]).

realiser(niveau_prop,_).




realiser(mode_prop,intensionnel).
realiser(mode_prop,enonce):-
	creer(sujet),
        preselect(sujet,[constituant,nominal]),
	ordre([...,sujet,...,predicat,...]).
realiser(mode_prop,commande):-
	ordre([predicat,...]).

realiser(processus,materiel):-
	inclure(acteur),
	inclure(but).
realiser(processus,mental):-
	inclure(senseur),
	inclure(phenomene).
realiser(processus,relationnel).
realiser(processus,evolutif) :-
	inclure(acteur),
	inclure(amplitude_variation).


realiser(voix,active):-
         trait(processus,materiel),conflater(sujet,acteur);
         trait(processus,evolutif),conflater(sujet,acteur);
         trait(processus,mental),conflater(sujet,senseur).

realiser(voix,passive):-
	(trait(processus,materiel),conflater(sujet,but);
         trait(processus,mental),conflater(sujet,phenomene)),
	 preselect(predicat,[auxiliaire,etre]).


realiser(extension_active,explicite):-
	 trait(processus,materiel),
	 creer(complement), 
	 conflater(complement,but),
	 preselect(complement,[constituant,nominal]).
realiser(extension_active,explicite):-
	 trait(processus,evolutif),
         \+ propriete(processus,trait_semantique(modif_verbal),_),
         creer(complement),
         conflater(complement,amplitude_variation),
	 preselect(complement,[constituant,adverbial]),
	 preselect(complement,[type_adverbial,variation]).



realiser(adjoint_secondaire,oui):-
         propriete(processus,trait_semantique(modif_verbal),_),
	 trait(processus,evolutif),
         preselect(amplitude_variation,[constituant,adverbial]),
	 preselect(amplitude_variation,[type_adverbial,variation]),
         preselect(amplitude_variation,[adverbial_parenthese,oui]),
         preselect(amplitude_variation,[forme_variation,concise]),
	 ordre([...,predicat,...,amplitude_variation,...]).
realiser(adjoint_secondaire,non).     	

realiser(extension_active,implicite).

realiser(reflexivite,reflexif):-
	ordre([...,complement,predicat,...]),
	preselect(complement,[constituant,nominal]),
	preselect(complement,[reference,textuelle..pronominalisation]),
	preselect(complement,[complexite,simple]),
        preselect(complement,[complexite,simple]),
	preselect(predicat,[auxiliaire,etre]).
realiser(reflexivite,non_reflexif):-
	ordre([...,predicat,complement,...]).


realiser(extension_passive,explicite):-
	creer(complement),
        preselect(complement,[constituant,nominal]),
	(trait(processus,materiel),conflater(complement,acteur);
	 trait(processus,mental),conflater(complement,senseur)),
	 creer(preposition),
	 attribuer(preposition,lex,par),
	 ordre([...,predicat,preposition,complement,...]).
realiser(extension_passive,implicite).

realiser(aspect,_).
realiser(type_sit,_).


realiser(localisation,Temps):-
        member(Temps,[passe,present,futur]),
	preselect(predicat,[loc_temps,Temps]).
realiser(localisation,atemporelle).

realiser(circ_temporelle,oui):-
	inclure(circ_temp),
	preselect(circ_temp,[constituant,adverbial]),
        preselect(circ_temp,[type_adverbial,temporel]).
realiser(circ_temporelle,non).

realiser(circ_temp_thematise,oui):-
	ordre([circ_temp,...]).
realiser(circ_temp_thematise,non).

realiser(reference_acteur,anaphorique):-
	preselect(acteur,[reference,textuelle .. pronominalisation]).
realiser(reference_acteur,non_anaphorique).

realiser(reference_but,anaphorique):-
	preselect(but,[reference,textuelle .. pronominalisation]).
realiser(reference_but,non_anaphorique).




test(type_prop,complete):-
        propriete(type_message,even_simple).	
test(type_prop,partielle_nominale):-
	propriete(type_message,objet).
test(type_prop,partielle_adverbiale):-
        propriete(type_message,localisateur).



test(voix,active):-
	propriete(meme_ref(theme,acteur),oui);
        propriete(meme_ref(theme,senseur),oui).
test(voix,passive).


test(mode_prop,commande):-
        propriete(interp,commande).
test(mode_prop,enonce).
 
test(processus,P):-
        propriete(type_processus,P).

test(extension_active,explicite):-
	existe(but);
	existe(amplitude_variation),
        \+ propriete(processus,trait_semantique(modif_verbal),_);
	existe(phenomene).
test(extension_active,implicite).

test(extension_passive,explicite):-
	existe(acteur);
	existe(senseur).
test(extension_passive,implicite).

test(adjoint_secondaire,oui):-
	existe(amplitude_variation),
	propriete(processus,trait_semantique(modif_verbal),_).


test(aspect,Asp):-
	propriete(aspect,Asp).

test(type_sit,T):-
	propriete(type_situation,T).


test(localisation,T):-
        test_loc(loc,T);
        test_loc(even,T).

test_loc(X,passe):-
	propriete(relation(X,enon),avant).
test_loc(X,present):-
	propriete(relation(X,enon),simultane),
        \+ propriete(type_rel,termpar).
        
test_loc(X,futur):-
	propriete(relation(enon,X),avant);
	propriete(relation(X,enon),simultane),
        propriete(type_rel,term).

test(reflexivite,reflexif):-
        propriete(meme_ref(sujet,complement),oui).
test(reflexivite,non_reflexif):-
        propriete(meme_ref(sujet,complement),non).

test(circ_temporelle,oui):-
	propriete(loc_temporelle,specifiee).
test(circ_temporelle,non).





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                       Groupe nominal                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

systeme(genre_gn,[masculin,feminin],erreur).
systeme(nombre_gn,[singulier,pluriel],singulier).
systeme(reference,[textuelle,exterieure],exterieure).
systeme(anaphore,[designation,pronominalisation,repetition],pronominalisation).
systeme(emphase_designation,[oui,non],non).
systeme(design_gn,[definie,indefinie],erreur).
systeme(quant_gn,[quantifie,non_quantifie],erreur).
systeme(ident_gn,[directe,indirecte],erreur).
systeme(referent_dir,[pays,autre],erreur).
systeme(id_ind,[identifie,non_identifie],erreur).
systeme(complexite,[compose,simple],simple).
systeme(complementation,[attributif,autre],autre).
systeme(specificateur,[oui,non],non).
systeme(type_specificateur,[position,autre],non).


suite(constituant,nominal,conj([genre_gn,nombre_gn,reference,complexite])).
suite(genre_gn,_,fin).
suite(nombre_gn,_,fin).

suite(reference,textuelle,anaphore).
suite(reference,exterieure,conj([quant_gn,specificateur,design_gn])).

suite(anaphore,designation,emphase_designation).
suite(anaphore,_,fin).

suite(emphase_designation,_,fin).

suite(design_gn,indefinie,fin).
suite(design_gn,definie,ident_gn).

suite(ident_gn,directe,referent_dir).
suite(ident_gn,indirecte,id_ind).

suite(id_ind,_,fin).

suite(referent_dir,_,fin).

suite(quant_gn,_,fin).

suite(specificateur,oui,type_specificateur).
suite(specificateur,non,fin).

suite(type_specificateur,_,fin).

suite(complexite,compose,complementation).
suite(complexite,simple,fin).

suite(complementation,_,fin).

realiser(constituant,nominal):-
	inclure(tete),
	ordre([...,tete,...]).

realiser(genre_gn,_).
realiser(nombre_gn,_).


realiser(reference,textuelle) :-
	preselect(constituant,[complexite,simple]).
realiser(reference,exterieure):-
        trait(genre_gn,G),                           	
        trait(nombre_gn,N),  
	preselect(tete,[constituant,nom]),
	preselect(tete,[genre_nom,G]),
	preselect(tete,[nombre_nom,N]).

realiser(anaphore,designation):-
	trait(genre_gn,G),
	trait(nombre_gn,N),
	inclure(det),
	preselect(det,[constituant,article]),
	preselect(det,[def_art,demonstratif]),
	preselect(det,[genre_art,G]),
	preselect(det,[nombre_art,N]),
	preselect(tete,[constituant,nom]),
	preselect(tete,[genre_nom,G]),
	preselect(tete,[nombre_nom,N]).

realiser(emphase_designation,oui):-
        creer(det2),
        attribuer(det2,lex,'l'),
        ordre([det,...,det2]).
realiser(emphase_designation,non):-
        ordre([det,...]).


realiser(anaphore,pronominalisation):-
	trait(genre_gn,G),
	trait(nombre_gn,N),
        preselect(tete,[constituant,pronom]),
	preselect(tete,[genre_pro,G]),
	preselect(tete,[nombre_pro,N]).
realiser(anaphore,repetition):-
	trait(genre_gn,G),
	trait(nombre_gn,N),
	inclure(det),
	preselect(det,[constituant,article]),
	preselect(det,[def_art,defini]),
	preselect(det,[genre_art,G]),
	preselect(det,[nombre_art,N]),
	preselect(tete,[constituant,nom]),
	preselect(tete,[genre_nom,G]),
	preselect(tete,[nombre_nom,N]),
        ordre([det,...]).


realiser(design_gn,indefinie):-
        trait(quant_gn,non_quantifie),
	inclure(det),
	ordre([det,...]),
	trait(nombre_gn,N),
        trait(genre_gn,G),
	preselect(det,[constituant,article]),
	preselect(det,[def_art,indefini]),
	preselect(det,[genre_art,G]),
	preselect(det,[nombre_art,N]).
realiser(design_gn,indefinie).
realiser(design_gn,definie).
   



realiser(quant_gn,non_quantifie).
realiser(quant_gn,quantifie):-
        inclure(quantificateur),
        ordre([...,quantificateur,...,tete,...]),
        lexicaliser(quantificateur,adjectif(numeral)).



realiser(specificateur,oui):-
	inclure(specificateur),
	ordre([...,specificateur,tete,...]).
realiser(specificateur,non).

realiser(type_specificateur,position):-
	preselect(specificateur,[constituant,adjectif]),
	preselect(specificateur,[cat_adj,numeral..ordinal]),
        trait(genre_gn,G),
	preselect(specificateur,[genre_adj,G]).
realiser(type_specificateur,autre).



realiser(ident_gn,directe):-
        preselect(tete,[type_nom,propre]).
realiser(ident_gn,indirecte):-
        preselect(tete,[type_nom,commun]),
	inclure(det),
        (trait(quant_gn,quantifie)->
             ordre([det,quantificateur,...]);
	     ordre([det,...])),
	trait(nombre_gn,N),
        trait(genre_gn,G),
	preselect(det,[constituant,article]),
	preselect(det,[def_art,defini]),
	preselect(det,[genre_art,G]),
	preselect(det,[nombre_art,N]).

realiser(referent_dir,pays):-
        val_sem(constituant,[message === Sem]),
	desc(Sem,L), member(id(Pays),L),
	trait_lexical(nom,Pays,article===absent).
realiser(referent_dir,pays) :-
	inclure(det),
	ordre([det,...]),
	trait(nombre_gn,N),
        trait(genre_gn,G),
	preselect(det,[constituant,article]),
	preselect(det,[def_art,defini]),
	preselect(det,[genre_art,G]),
	preselect(det,[nombre_art,N]). 
realiser(referent_dir,autre).
        

realiser(id_ind,identifie):-
        inclure(identificateur),
	preselect(identificateur,[constituant,nom]),
        preselect(identificateur,[type_nom,propre]),
	trait(nombre_gn,N),
        trait(genre_gn,G),
	preselect(identificateur,[genre_nom,G]),
	preselect(identificateur,[nombre_nom,N]),
        ordre([...,tete,identificateur,...]).
realiser(id_ind,non_identifie).



realiser(complexite,compose):-
        inclure(comp_nom).
realiser(complexite,simple).

realiser(complementation,attributif):-
	creer(attributeur),
        attribuer(attributeur,lex,de),
        preselect(comp_nom,[constituant,nominal]),
        ordre([...,tete,...,attributeur,comp_nom,...]).
realiser(complementation,autre).


test(reference,textuelle):-
	propriete(tete,contexte(id),oui),
	propriete(tete,contexte(onto),oui).
test(reference,textuelle):-
	propriete(tete,contexte(onto),oui),
        \+ propriete(tete,identificateur,_).
test(reference,exterieure).


test(genre_gn,Genre):-
	propriete(tete,genre,Genre).

test(nombre_gn,Nombre):-
	propriete(tete,nombre,Nombre).


test(anaphore,pronominalisation):-
	 propriete(tete,role_comm,locuteur);
	 propriete(tete,role_comm,interlocuteur).


test(design_gn,definie):-
	propriete(tete,identificateur,_);
        propriete(tete,connu,oui);
        propriete(tete,contexte(onto),oui).	
test(design_gn,indefinie).


test(quant_gn,quantifie):-
        propriete(tete,trait_semantique(quantite),_),
        \+ propriete(tete,contexte(quantite),oui).
test(quant_gn,non_quantifie).


test(ident_gn,directe):-
	propriete(tete,identificateur,_),
        propriete(tete,type_objet_refere,T),
        trait_lexical(nom,T,id===implicite).
test(ident_gn,directe):-
	propriete(tete,identificateur,_),
        propriete(tete,contexte(onto),oui).
test(ident_gn,indirecte).


test(referent_dir,pays):-
	propriete(tete,type_objet_refere,pays);
	propriete(tete,type_objet_refere,continent);
	propriete(tete,type_objet_refere,province).
test(referent_dir,autre).


test(id_ind,identifie):-
	propriete(tete,identificateur,_),
        \+ propriete(tete,contexte(id),oui).
test(id_ind,non_identifie).           



test(complexite,X):-
   propriete(complexite,X).

test(complementation,X):-
   propriete(complementation,X).
    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                          Nom                               %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

systeme(type_nom,[propre,commun],commun).
systeme(genre_nom,[masculin,feminin],erreur).
systeme(nombre_nom,[singulier,pluriel],erreur).

suite(constituant,nom,conj([genre_nom,nombre_nom,type_nom])).
suite(type_nom,_,fin).
suite(genre_nom,masculin,fin).
suite(genre_nom,feminin,fin).
suite(nombre_nom,singulier,fin).
suite(nombre_nom,pluriel,fin).


realiser(constituant,nom):-
	creer(id_referent),
        lexicaliser(id_referent,nom),
        morpho(id_referent),
        ordre([id_referent]).


realiser(genre_nom,_).
realiser(nombre_nom,_).
realiser(type_nom,propre):-
	inclure(id_ref),
        conflater(id_ref,id_referent).
realiser(type_nom,commun):-
	inclure(onto_ref),
        conflater(onto_ref,id_referent).

        


test(type_nom,propre):-
	propriete(propre,oui).
test(type_nom,commun).



% Tous les autres sont choisis par preselection


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                            Pronom                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

systeme(type_pro,[interrogatif,personnel,relatif,
                  possessif,demonstratif,indefini],personnel).
systeme(position_pro,[conjoint,disjoint],erreur).
systeme(fonction_pro,[subjectif,objectif,reflexif],objectif).
systeme(extension_pro,[direct,indirect],erreur).
systeme(pro_anim,[anime,inanime],erreur).
systeme(personne_pro,[1,2,3],erreur).
systeme(genre_pro,[masculin,feminin,nil],nil).
systeme(nombre_pro,[singulier,pluriel],erreur).

suite(type_pro,personnel,conj([position_pro,fonction_pro,
                               personne_pro,genre_pro,
	                       nombre_pro])).


suite(constituant,pronom,type_pro).
suite(personne_pro,_,fin).
suite(position_pro,_,fin).
suite(fonction_pro,_,fin).
suite(pro_anim,_,fin).
suite(nombre_pro,_,fin).
suite(genre_pro,_,fin).


realiser(constituant,pronom):-
	creer(mot_pronom),
        val_sem(constituant,Sem),
        attribuer_semantique(mot_pronom,Sem),
        lexicaliser(mot_pronom,pronom),
        morpho(mot_pronom),
	ordre([mot_pronom]).

realiser(type_pro,personnel).

realiser(position_pro,_).
realiser(pro_anim,_).
realiser(fonction_pro,_).
realiser(personne_pro,_).
realiser(nombre_pro,_).
realiser(genre_pro,_).




test(fonction_pro,reflexif):-
        propriete(meme_ref(prop..sujet,prop..complement),oui),
        propriete(id(prop..complement,constituant),oui).
test(fonction_pro,subjectif):-
        propriete(id(prop..sujet,constituant),oui).
test(fonction_pro,objectif):-
        propriete(meme_ref(prop..complement,prop..sujet),non),
        propriete(id(prop..complement,constituant),oui).



test(position_pro,conjoint).

test(personne_pro,1):-
	propriete(role_comm,locuteur).
test(personne_pro,2):-
	propriete(role_comm,interlocuteur).
test(personne_pro,3):-
	propriete(role_comm,tiers).



	



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                      Article                            %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

systeme(def_art,[defini,indefini,demonstratif],erreur).
systeme(genre_art,[masculin,feminin],erreur).
systeme(nombre_art,[singulier,pluriel],erreur).


suite(constituant,article,conj([def_art,genre_art,
	           nombre_art])).

suite(def_art,_,fin).
suite(genre_art,_,fin).
suite(nombre_art,_,fin).
suite(nombre_art,pluriel,fin).


realiser(constituant,article):-
	creer(radical),
        lexicaliser(radical,article),
        morpho(radical),
	ordre([radical]).
realiser(def_art,defini):-
	attribuer(radical,lex,le).
realiser(def_art,indefini):-
	attribuer(radical,lex,un).
realiser(def_art,demonstratif):-
	attribuer(radical,lex,ce).

realiser(genre_art,_).
realiser(nombre_art,_).




% Pas de test. Tout est preselectionne par le groupe nominal
	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Groupe verbal                        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
systeme(loc_temps,[passe,present,futur],present).
systeme(tv_passe,[imp,pqp,pc_ps],erreur).
systeme(tv_present,[pres,pc_acc],erreur).
systeme(tv_futur,[fs,f_ant],erreur).
systeme(auxiliaire,[avoir,etre],avoir).
systeme(prolong_verbe,[requis,non_requis],non_requis).
systeme(prep_verbe,[destination,origine],erreur).
systeme(modificateur_verbal,[present,absent],absent).

suite(constituant,verbal,conj([loc_temps,prolong_verbe,modificateur_verbal])).
suite(auxiliaire,_,fin).
suite(loc_temps,passe,tv_passe).
suite(loc_temps,present,tv_present).
suite(loc_temps,futur,tv_futur).
suite(tv_passe,pc_ps,auxiliaire).
suite(tv_passe,pqp,auxiliaire).
suite(tv_passe,imp,fin).
suite(tv_present,pres,fin).
suite(tv_present,pc_acc,auxiliaire).
suite(tv_futur,fs,fin).
suite(tv_futur,f_ant,auxiliaire).
suite(prolong_verbe,requis,prep_verbe).
suite(prolong_verbe,non_requis,fin).
suite(prep_verbe,_,fin).
suite(modificateur_verbal,_,fin).
 
realiser(constituant,verbal):-
	val_sem(prop .. predicat,U),
	creer(verbe_princ),
	attribuer_semantique(verbe_princ,U),
	preselect(verbe_princ,[constituant,verbe]),
	ordre([...,verbe_princ,...]).

 
realiser(auxiliaire,avoir):-
	attribuer(aux,message,avoir),
	preselect(verbe_princ,[verbe_mode,participe..passe..invariable]),
	ordre([aux,verbe_princ,...]).

realiser(auxiliaire,etre):-
	attribuer(aux,message,etre),
	preselect(verbe_princ,[verbe_mode,participe..passe..variable]),
	ordre([aux,verbe_princ,...]).

realiser(loc_temps,_).

realiser(tv_passe,pc_ps):-
	creer(aux),
	preselect(aux,[constituant,verbe]),
	preselect(aux,[verbe_mode,indicatif]),
	preselect(aux,[temps_verbe,present]).
realiser(tv_passe,pqp):-
	creer(aux),
	preselect(aux,[constituant,verbe]),
	preselect(aux,[verbe_mode,indicatif]),
	preselect(aux,[temps_verbe,imparfait]).
realiser(tv_passe,imp):-
	preselect(verbe_princ,[verbe_mode,indicatif]),
	preselect(verbe_princ,[temps_verbe,imparfait]).

realiser(tv_present,pc_acc):-
	creer(aux),
	preselect(aux,[constituant,verbe]),
	preselect(aux,[verbe_mode,indicatif]),
	preselect(aux,[temps_verbe,present]).
realiser(tv_present,pres):-
	preselect(verbe_princ,[verbe_mode,indicatif]),
	preselect(verbe_princ,[temps_verbe,present]).
	
realiser(tv_futur,f_ant):-
	creer(aux),
	preselect(aux,[constituant,verbe]),
	preselect(aux,[verbe_mode,indicatif]),
	preselect(aux,[temps_verbe,futur]).
realiser(tv_futur,fs):-
	preselect(verbe_princ,[verbe_mode,indicatif]),
	preselect(verbe_princ,[temps_verbe,futur]).

realiser(prolong_verbe,requis):-
	creer(prep_du_verbe),
	ordre([...,verbe_princ,...,prep_du_verbe]).
realiser(prolong_verbe,_).

realiser(prep_verbe,destination):-
	attribuer(prep_du_verbe,lex,'').
realiser(prep_verbe,origine):-
	attribuer(prep_du_verbe,lex,de).

realiser(modificateur_verbal,present):-
	inclure(modif_verbal),
	lexicaliser(modif_verbal,adverbe),
	ordre([...,verbe_princ,modif_verbal,...]).
realiser(modificateur_verbal,absent).
 


test(auxiliaire,avoir):-
	propriete(verbe_princ,composition,auxiliaire(avoir)).
test(auxiliaire,etre):-
	propriete(verbe_princ,composition,auxiliaire(etre)).

test(tv_passe,imp):-
	 trait(prop,aspect,situation),
	 trait(prop,type_sit,ouverte).
test(tv_passe,pqp):-
	 trait(prop,aspect,situation),
	 trait(prop,type_sit,resultante).	
test(tv_passe,pqp):-
	 trait(prop,aspect,evenement),
	 (propriete(relation(loc,persp),avant);
	  propriete(relation(even,persp),avant)),
	 propriete(relation(persp,enon),avant).
test(tv_passe,pc_ps).



test(tv_present,TV):-
	trait(prop,aspect,evenement),
	   TV = pres;

	 trait(prop,type_sit,ouverte),
	   TV = pres;

	 trait(prop,type_sit,resultante),
	   TV = pc_acc.

test(tv_futur,fs):-
        trait(prop,aspect,evenement);
        trait(prop,type_sit,ouverte).
test(tv_futur,f_ant):-
	trait(prop,type_sit,resultante).


test(prolong_verbe,requis):-
	propriete(verbe_princ,prolongation_verbe,_).
test(prolong_verbe,non_requis).

test(prep_verbe,Type):-
	propriete(verbe_princ,prolongation_verbe,Type).

	
test(modificateur_verbal,present):-
    propriete(modif_verbal,_).
test(modificateur_verbal,absent).
 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                       Verbe                             %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

systeme(verbe_mode,[participe,imperatif,
                    indicatif,infinitif],
                    infinitif).
systeme(temps_part,[passe,present],passe).
systeme(accord_part,[variable,invariable],invariable).
systeme(genre_verbe,[masculin,feminin,nil],nil).
systeme(nombre_verbe,[singulier,pluriel,nil],nil).
systeme(personne_verbe,[1,2,3,nil],nil).
systeme(temps_verbe,[passe,imparfait,present,futur],present).


suite(constituant,verbe,verbe_mode).
suite(verbe_mode,participe,temps_part).
suite(verbe_mode,imperatif,conj([temps_verbe,personne_verbe,
	                         nombre_verbe,genre_verbe])).
suite(verbe_mode,indicatif,conj([temps_verbe,personne_verbe,
	                         nombre_verbe,genre_verbe])).
suite(verbe_mode,infinitif,fin).

suite(temps_part,passe,accord_part).
suite(temps_part,present,conj([temps_verbe,personne_verbe,
	                         nombre_verbe,genre_verbe])).

suite(accord_part,variable,conj([temps_verbe,personne_verbe,
	                         nombre_verbe,genre_verbe])).

suite(accord_part,invariable,
                           conj([temps_verbe,personne_verbe,
	                         nombre_verbe,genre_verbe])).

suite(genre_verbe,_,fin).
suite(temps_verbe,_,fin).
suite(personne_verbe,_,fin).
suite(nombre_verbe,_,fin).


realiser(constituant,verbe):-
	creer(mot_verbe),
        val_sem(constituant,S),
        attribuer_semantique(mot_verbe,S),
	lexicaliser(mot_verbe,verbe),
        morpho(mot_verbe),
	ordre([mot_verbe]).

realiser(verbe_mode,participe).
realiser(verbe_mode,imperatif):-
	preselect([temps_verbe,present]).

realiser(verbe_mode,indicatif).
realiser(verbe_mode,infinitif).


realiser(temps_part,passe):-
	preselect([temps_verbe,passe]).
realiser(temps_part,present):-
	preselect([temps_verbe,present]).

realiser(accord_part,variable).
realiser(accord_part,invariable):-
	preselect([genre_verbe,nil]),
	preselect([nombre_verbe,nil]).

realiser(genre_verbe,_).
realiser(temps_verbe,_).
realiser(personne_verbe,_).
realiser(nombre_verbe,_).


test(verbe_mode,Vmode):-
	trait(prop,mode_prop,Mode),
        (Mode = enonce,      Vmode = indicatif;
         Mode = commande,    Vmode = imperatif;
         Mode = intensionnel,Vmode = infinitif).

test(genre_verbe,G):-
	trait(prop .. sujet, genre_gn,G).

test(nombre_verbe,N):-
	(trait(verbe_mode,indicatif);
         trait(verbe_mode,participe)),
	trait(prop .. sujet, nombre_gn,N).
	
test(personne_verbe,P):-
	propriete(prop..sujet,role_comm,Role),
        (Role = locuteur, P=1;
         Role = interlocuteur, P=2;
	 P=3).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Groupe adverbial                     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

systeme(adverbial_parenthese,[oui,non],non).
systeme(type_adverbial,[temporel,variation,autre],erreur).
systeme(type_variation,[bornee,delta],erreur).
systeme(forme_variation,[complete,concise],complete).
systeme(qte_ancrage,[unique,double],erreur).
systeme(ancrage,[anaphorique,deictique,autonome],erreur).
systeme(ancrage1,[anaphorique,deictique,autonome],erreur).
systeme(ancrage2,[anaphorique,deictique,autonome],erreur).
systeme(niveau_loc,[primaire,secondaire],primaire).
systeme(aspect_loc,[duratif,ponctuel],erreur).
systeme(des_duree_fermee,[directe,relative],erreur).
systeme(type_duree,[bornee,quantifiee],erreur).
systeme(ancrage_duree,[ante,post,double],erreur).
systeme(persp_duree,[interne,externe],erreur).
systeme(des_zone_temp,[directe,relationnelle],erreur).
systeme(ref_int,[occurrentielle,chronologique],erreur).
systeme(nomin_occ,[nominalisee,non_nominalisee],non_nominalisee).
systeme(zone_ref,[ellipse,present],erreur).
systeme(type_relation,[anteriorite,posteriorite,entre,deb,term],erreur).
systeme(repere_loc,[enonciation,reference,nil],erreur).
systeme(ref_cadre,[implicite,explicite],erreur).
systeme(denom_zone,[directe,pos_dans_ordre],erreur).
systeme(pos_repere_loc,[positionne,non_positionne],erreur).
systeme(persp_enon,[ponctuel,duratif],erreur).
systeme(unite_cadre,[minute,heure,jour,semaine,mois,saison,annee,indefini],indefini).
systeme(exp_decalage,[implicite,explicite],explicite).
systeme(ref_agent_loc_occ,[idem,differents],erreur).
systeme(id_decalage,[defini,indefini],erreur).
systeme(val_dec,[1,2,autre],erreur).

suite(constituant,adverbial,conj([adverbial_parenthese,type_adverbial])).
suite(adverbial_parenthese,_,fin).
suite(type_adverbial,variation,conj([forme_variation,type_variation])).
suite(type_variation,_,fin).
suite(forme_variation,_,fin).
suite(type_adverbial,temporel,conj([niveau_loc,qte_ancrage,unite_cadre,
                                  des_zone_temp])).
suite(qte_ancrage,unique,ancrage).
suite(qte_ancrage,double,conj([ancrage1,ancrage2])).
suite(ancrage,_,fin).
suite(ancrage1,_,fin).
suite(ancrage2,_,fin).
suite(ancrage_duree,ante,persp_duree).
suite(ancrage_duree,_,fin).
suite(persp_duree,fin).
suite(aspect_loc,duratif,type_duree).
suite(aspect_loc,ponctuel,type_relation).
suite(des_zone_temp,directe,ref_int).
suite(des_zone_temp,relationnelle,aspect_loc).
suite(exp_decalage,_,fin).
suite(niveau_loc,_,fin).
suite(nomin_occ,_,fin).
suite(persp_enon,_,fin).
suite(ref_agent_loc_occ,_,fin).
suite(ref_int,chronologique,repere_loc).
suite(ref_int,occurrentielle,conj([nomin_occ,ref_agent_loc_occ])).
suite(repere_loc,enonciation,persp_enon).
suite(repere_loc,nil,conj([ref_cadre,denom_zone,pos_repere_loc])).
suite(repere_loc,reference,pos_repere_loc).
suite(pos_repere_loc,_,fin).
suite(ref_cadre,_,fin).
suite(denom_zone,_,fin).
suite(type_relation,anteriorite,conj([zone_ref,id_decalage])).
suite(type_relation,entre,fin).
suite(type_relation,deb,fin).
suite(type_relation,term,fin).
suite(type_relation,posteriorite,conj([zone_ref,id_decalage])).
suite(id_decalage,defini,conj([val_dec,exp_decalage])).
suite(val_dec,_,fin).
suite(id_decalage,indefini,fin).
suite(unite_cadre,_,fin).
suite(zone_ref,_,fin).
suite(type_duree,bornee,ancrage_duree).
suite(type_duree,quantifiee,fin).




realiser(adverbial_parenthese,oui):-
	creer(debut_parenthese_adv),
	creer(fin_parenthese_adv),
        attribuer(debut_parenthese_adv,lex,'('),
	attribuer(fin_parenthese_adv,lex,')'),
        ordre([debut_parenthese_adv,...,fin_parenthese_adv]).
realiser(adverbial_parenthese,non).


realiser(qte_ancrage,_).

realiser(ancrage,_).

realiser(ancrage1,_).

realiser(ancrage2,_).

realiser(constituant,adverbial).

realiser(niveau_loc,_).

realiser(aspect_loc,duratif).

realiser(aspect_loc,ponctuel).

realiser(type_adverbial,_).

realiser(unite_cadre,_).

realiser(nomin_occ,nominalisee).
realiser(nomin_occ,non_nominalisee):-
    creer(prep_occ),
    creer(prop),
    conflater(prop,des_zone),
    (trait(niveau_loc,secondaire) -> 
         attribuer(prep_occ,lex,que); 
         attribuer(prep_occ,lex,quand)),
    preselect(prop,[constituant,proposition]),
    preselect(prop,[circ_temporelle,non]),
    preselect(prop,[voix,active]),
    ordre([...,prep_occ,prop,...]).

realiser(type_duree,bornee).    
realiser(type_duree,quantifiee):-
    inclure(zone_ref_temp),
    inclure(quant_duree),
    lexicaliser(positionneur,preposition(temporelle)),
    preselect(quant_duree,[constituant,nominal]),
    ordre([...,positionneur,quant_duree,...]).



realiser(forme_variation,_).


realiser(type_variation,bornee):-
    trait(forme_variation,concise),
    creer(marqueur_lien_variation),
    attribuer(marqueur_lien_variation,lex,'-'),
    inclure(valeur_init_variation),
    inclure(valeur_finale_variation),
    preselect(valeur_init_variation,[constituant,nominal]),
    preselect(valeur_finale_variation,[constituant,nominal]),
    ordre([...,valeur_init_variation,marqueur_lien_variation,
           valeur_finale_variation,...]).
realiser(type_variation,bornee):-
    trait(forme_variation,complete),
    creer(prep1),
    inclure(valeur_init_variation),
    creer(prep2),
    inclure(valeur_finale_variation),
    ordre([...,prep1,valeur_init_variation,prep2,valeur_finale_variation,...]),
    preselect(valeur_init_variation,[constituant,nominal]),
    preselect(valeur_finale_variation,[constituant,nominal]),
    attribuer(prep1,lex,de),
    attribuer(prep2,lex,'').



realiser(type_variation,delta):-
    trait(forme_variation,concise),
    inclure(valeur_variation),
    ordre([...,valeur_variation,...]),
    preselect(valeur_variation,[constituant,nominal]).
realiser(type_variation,delta):-
    trait(forme_variation,complete),
    creer(prep),
    attribuer(prep,lex,de),
    inclure(valeur_variation),
    ordre([...,prep,valeur_variation,...]),
    preselect(valeur_variation,[constituant,nominal]).




    
realiser(ancrage_duree,post):-
    inclure(zone_ref_temp),
    lexicaliser(positionneur,preposition(temporelle)),
    preselect(zone_ref_temp,[constituant,adverbial]),
    preselect(zone_ref_temp,[type_adverbial,temporel]),
    preselect(zone_ref_temp,[niveau_loc,secondaire]),
    preselect(zone_ref_temp,[pos_repere_loc,positionne]),
    ordre([...,positionneur,zone_ref_temp,...]).
realiser(ancrage_duree,ante):-
    inclure(zone_ref_temp),
    lexicaliser(positionneur,preposition(temporelle)),
    preselect(zone_ref_temp,[constituant,adverbial]),
    preselect(zone_ref_temp,[type_adverbial,temporel]),
    preselect(zone_ref_temp,[niveau_loc,secondaire]),
    preselect(zone_ref_temp,[pos_repere_loc,non_positionne]),
    ordre([...,positionneur,zone_ref_temp,...]).
realiser(ancrage_duree,double):-
    inclure(ancrage_ante),
    inclure(ancrage_post),
    creer(det_origine),
    creer(det_dest),
    attribuer(det_origine,lex,de),
    attribuer(det_dest,lex,''),
    preselect(ancrage_ante,[constituant,adverbial]),
    preselect(ancrage_ante,[type_adverbial,temporel]),
    preselect(ancrage_ante,[niveau_loc,secondaire]),
    preselect(ancrage_post,[constituant,adverbial]),
    preselect(ancrage_post,[type_adverbial,temporel]),
    preselect(ancrage_post,[niveau_loc,secondaire]),
    ordre([...,det_origine,ancrage_ante,det_dest,ancrage_post,...]).



realiser(persp_duree,_).

realiser(des_zone_temp,directe):-
    inclure(des_zone).
realiser(des_zone_temp,relationnelle):-
    inclure(positionneur).


realiser(zone_ref,ellipse):-
    ordre([...,positionneur,...]).   
realiser(zone_ref,present):-
    inclure(zone_ref_temp),
    creer(circ_temp),
    conflater(zone_ref_temp,circ_temp),
    preselect(zone_ref_temp,[constituant,adverbial]),
    preselect(zone_ref_temp,[type_adverbial,temporel]),
    preselect(zone_ref_temp,[niveau_loc,secondaire]),
    ordre([...,positionneur,zone_ref_temp,...]).


realiser(id_decalage,defini).
realiser(id_decalage,indefini):-
     trait(zone_ref,ellipse),lexicaliser(positionneur,adverbe);
     trait(zone_ref,present),lexicaliser(positionneur,preposition(temporelle)).


realiser(val_dec,_).

realiser(exp_decalage,explicite):-
    inclure(decalage_temporel),
    preselect(decalage_temporel,[constituant,nominal]),
    lexicaliser(positionneur,preposition(temporelle)),
    (trait(ancrage,deictique) ->
	ordre([...,positionneur,decalage_temporel,...]);
        ordre([...,decalage_temporel,positionneur,...])).
realiser(exp_decalage,implicite):-
    (trait(ancrage,deictique),
     trait(unite_cadre,jour),
     lexicaliser(positionneur,adverbe);

     trait(ancrage,anaphorique),
     trait(unite_cadre,jour),
     lexicaliser(positionneur,locution(nominale)); 

     trait(unite_cadre,annee),
     preselect(positionneur,[constituant,nominal])).
     

realiser(type_relation,_).

    
realiser(ref_int,occurrentielle).
realiser(ref_int,chronologique):-
    ordre([...,des_zone,...]).

realiser(repere_loc,enonciation).
realiser(repere_loc,reference):-
    preselect(des_zone,[constituant,nominal]),
    preselect(des_zone,[reference,textuelle..designation..oui]).
realiser(repere_loc,nil).


realiser(ref_cadre,explicite):-
    inclure(zone_ref_temp),
    preselect(zone_ref_temp,[constituant,adverbial]),
    preselect(zone_ref_temp,[type_adverbial,temporel]),
    preselect(zone_ref_temp,[niveau_loc,secondaire]),
    creer(attributeur),
    attribuer(attributeur,lex,de),
    ordre([...,des_zone,attributeur,zone_ref_temp,...]).
realiser(ref_cadre,implicite).

realiser(denom_zone,directe):-
    trait(unite_cadre,saison),
    preselect(des_zone,[constituant,nominal]),
    preselect(des_zone,[reference,exterieure]),
    preselect(des_zone,[design_gn,definie]). 
realiser(denom_zone,directe):-
    lexicaliser(des_zone,loc_temp).
realiser(denom_zone,pos_dans_ordre):-
    preselect(des_zone,[constituant,nominal]),
    preselect(des_zone,[reference,exterieure]),
    preselect(des_zone,[specificateur,oui..position]),
    preselect(des_zone,[design_gn,definie]). 



realiser(pos_repere_loc,positionne):-
    inclure(positionneur),
    lexicaliser(positionneur,preposition),
    ordre([...,positionneur,des_zone,...]).
realiser(pos_repere_loc,non_positionne).
    


realiser(ref_agent_loc_occ,idem):-
    preselect(des_zone,[reference_acteur,anaphorique]).
realiser(ref_agent_loc_occ,differents).
    
realiser(persp_enon,ponctuel):-
    lexicaliser(des_zone,adverbe).
realiser(persp_enon,duratif):-
    trait(unite_cadre,indefini),
    lexicaliser(des_zone,adverbe).
realiser(persp_enon,duratif):-
    trait(unite_cadre,U),
    (U=jour ->
        lexicaliser(des_zone,adverbe);
        preselect(des_zone,[constituant,nominal]),
        preselect(des_zone,[reference,textuelle..designation])).

test(qte_ancrage,A):-
    propriete(ancrage,A).

    
test(ancrage,anaphorique):-
    propriete(relation(ancrage,enon),not(equ)),    
    (propriete(relation(ref,zone),incldans);
     propriete(relation(zone,ref),equ);
     propriete(relation(ancrage,ref),equ);
     propriete(relation(enon,ref),term)).
test(A,anaphorique):-
    member(A,[ancrage1,ancrage2]),
    propriete(relation(A,enon),not(equ)),    
    propriete(relation(A,ref),equ).
test(A,deictique):-
    member(A,[ancrage,ancrage1,ancrage2]),
    (propriete(relation(enon,A),incldans);
     propriete(relation(enon,A),equ);
     propriete(relation(enon,A),term)).
test(A,autonome):-
    member(A,[ancrage,ancrage1,ancrage2]).



test(type_variation,T) :-
  propriete(type_variation,T).


test(aspect_loc,duratif):-
    propriete(type_zone,duree).
test(aspect_loc,ponctuel).



test(type_duree,bornee):-
    propriete(type_zone,duree_bornee).
test(type_duree,quantifiee):-
    propriete(type_zone,duree_quantifiee).



test(ancrage_duree,double):-
    propriete(fermeture,double).
test(ancrage_duree,post):-
    \+ propriete(fermeture,double),
    propriete(fermeture,post).
test(ancrage_duree,ante):-
    \+ propriete(fermeture,double),
    propriete(fermeture,ante).


test(persp_duree,interne):-
    trait(prop,aspect,situation).
test(persp_duree,externe):-
    trait(prop,aspect,evenement).


test(ref_cadre,implicite):-
     propriete(complexite_loc,simple);
     \+ fonction_realisee(ancrage_post),
     propriete(circ_temp,cadre_contextuel,oui).

test(ref_cadre,explicite):-
     propriete(complexite_loc,composee),
     propriete(cadre_contextuel,non),
     \+ propriete(des_zone,type_zone,horaire).

test(des_zone_temp,directe):-

       propriete(type_zone,occurrence);
      
       propriete(type_zone,position);

       propriete(relation(zone,enon),incl);
 
       propriete(relation(zone,ref),incl);

       propriete(relation(zone,enon),equ);

       propriete(type_rel,incldans);

%       trait(ancrage,anaphorique),
%       propriete(type_zone,constante);

       propriete(relation(ref,zone),equ);

       propriete(type_rel,pos_rel),
       propriete(decalage_temporel,D),
       member(D,[-1,1]).
   
test(des_zone_temp,relationnelle):-
       propriete(type_rel,R),
       member(R,[decalage,duree,avant,apres,entre,etendue,termpar,debpar,deb,term]).


test(denom_zone,D):-
       propriete(denomination,D).

test(type_relation,S):-
    member(S,[anteriorite,posteriorite]),
    propriete(sens_relation,S).
test(type_relation,R):-
    propriete(type_rel,R).

test(zone_ref,ellipse):-
    propriete(sens_relation,S),
    trait(ancrage,L),
    (S = anteriorite; S = posteriorite),
    (L = anaphorique; L = deictique).
test(zone_ref,ellipse):-
    trait(ancrage,deictique),
    trait(niveau_loc,secondaire),
    propriete(sens_relation,anteriorite).
test(zone_ref,present).


test(id_decalage,defini):-
    propriete(decalage_temporel,D),
    D \== indefini.
test(id_decalage,indefini):-
    propriete(decalage_temporel,indefini).


test(val_dec,D):-
    (D=1; D=2),
    propriete(decalage_temporel,D).
test(val_dec,autre):-
    propriete(decalage_temporel,D),
    D > 2.


test(exp_decalage,implicite):-
    (trait(ancrage,deictique);trait(ancrage,anaphorique)),
    trait(unite_cadre,U),
    member(U,[jour,annee,semaine,mois]),
    propriete(decalage_temporel,1).



test(repere_loc,enonciation):-
	trait(ancrage,deictique).
test(repere_loc,enonciation):-
        propriete(relation(enon,loc),incldans).
test(repere_loc,reference):-
	trait(ancrage,anaphorique).
test(repere_loc,reference):-
        propriete(relation(ref,loc),incldans).
test(repere_loc,nil):-
	trait(ancrage,autonome).




test(pos_repere_loc,positionne):-
    trait(niveau_loc,primaire).
test(pos_repere_loc,non_positionne):-
    trait(niveau_loc,secondaire).


test(persp_enon,ponctuel):-
	trait(niveau_loc,secondaire).
test(persp_enon,duratif):-
	trait(niveau_loc,primaire).

test(unite_cadre,Unite):-
	propriete(unite,Unite).


test(ref_int,chronologique):-
	propriete(type_zone,constante).
test(ref_int,occurrentielle):-
	propriete(type_zone,occurrence).
	

test(ref_agent_loc_occ,idem):-
	val_sem(prop..acteur,A),
	propriete(acteur,Aloc),
	A == Aloc.
test(ref_agent_loc_occ,differents).

	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Preposition                          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

systeme(cat_prep,[temporelle,autre],erreur).

suite(constituant,preposition,cat_prep).
suite(cat_prep,_,fin).

realiser(constituant,preposition):-
        creer(mot_prep),
        lexicaliser(mot_prep,preposition),
        ordre([mot_prep]).

realiser(cat_prep,_).
 




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                      Adjectif                           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

systeme(genre_adj,[masculin,feminin],erreur).
systeme(nombre_adj,[singulier,pluriel],erreur).
systeme(cat_adj,[numeral,autre],erreur).
systeme(cat_adj_num,[cardinal,ordinal],erreur).

suite(constituant,adjectif,conj([cat_adj,genre_adj,
                                nombre_adj])).

suite(cat_adj,numeral,cat_adj_num).
suite(cat_adj,autre,fin).

suite(cat_adj_num,_,fin).
suite(genre_adj,_,fin).
suite(nombre_adj,_,fin).

realiser(constituant,adjectif):-
        inclure(mot_adj),
        lexicaliser(mot_adj,adjectif),
        ordre([mot_adj]).

realiser(cat_adj,_).
realiser(cat_adj_num,_).
realiser(genre_adj,_).
realiser(nombre_adj,_).

test(genre_adj,G):-
	trait(constituant,genre,G).

test(nombre_adj,singulier):-
	trait(cat_adj_num,ordinal).
test(nombre_adj,N):-
	trait(constituant,nombre,N).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                      Adverbe                           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

systeme(cat_adv,[temporel,autre],erreur).

suite(constituant,adverbe,cat_adv).
suite(cat_adv,_,fin).

realiser(constituant,adverbe):-
        creer(mot_adv),
        lexicaliser(mot_adv,adverbe),
        ordre([mot_adv]).


realiser(cat_adv,_).
