


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                              %
%                      LEXICALISATION                          %
%                                                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Dans le cas ou on a un mot simple, la valeur semantique associee
% a la fonction est deja un item lexical.
% Les noms propres
lex(nom,Sem,Traits,Sem):-
   member(type_nom===propre,Traits).
% Les autres noms
lex(nom,Sem,_,Lex):-
   lexique(nom,Sem,Lex,T).


lex(verbe,Sem,_,Lex):-
   lexique(verbe,Sem,Lex,T).



% Cas speciaux

%lex(adjectif(numeral),Nombre,_,Adj):-
%        traduire(Nombre,Adj).
lex(adjectif(numeral),Nombre,_,Nombre).



%Localisateur temporel denomination exprimee directement
lex(loc_temp,[_,minute,horaire(X,Y)],_,LocTemp):-
        lexique(loc_temp,horaire(X,Y),LocTemp,[]).
lex(loc_temp,[_,_,N],_,N).


% Cas general. On cherche un item lexical dont tous les traits
% qui lui sont associes dans le lexique se retrouvent dans les
% selections


lex(Cat,Sem,Traits,Item):-
    lexique(Cat,Sem,Item,Tlex),
    inclus_liste(Tlex,Traits).

   

        





% Cas d'erreur
lex(_,_,_,'????').






