

% Lexique


% Verbes
lexique(verbe,aller,aller,[processus===materiel,auxiliaire===tre,
                     requis===destination],aller).
lexique(verbe,augmenter,augmenter,[processus===evolutif,auxiliaire===avoir]).
lexique(verbe,allumer,allumer,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,appeler,appeler,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,arriver,arriver,[processus===materiel,auxiliaire===etre]).
lexique(verbe,atteindre,atteindre,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,avoir,avoir,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,chercher,chercher,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,clignoter,clignoter,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,decouvrir,'dcouvrir',[processus===materiel,auxiliaire===avoir]).
lexique(verbe,diminuer,diminuer,[processus===evolutif,auxiliaire===avoir]).
lexique(verbe,effectuer,effectuer,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,eteindre,'teindre',[processus===materiel,auxiliaire===avoir]).
lexique(verbe,etre,'tre',[processus===materiel,auxiliaire===avoir]).
lexique(verbe,exploser,exploser,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,faire,faire,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,fonctionner,fonctionner,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,lire,lire,[processus===mental,auxiliaire===avoir]).
lexique(verbe,poser,poser,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,programmer,programmer,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,quitter,quitter,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,remercier,remercier,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,survoler,survoler,[processus===materiel,auxiliaire===avoir]).
lexique(verbe,trouver,trouver,[processus===materiel,auxiliaire===avoir]).






% Noms

lexique(nom, 'Alberta', 'Alberta', [genre === feminin]).
lexique(nom, 'Colombie-Britannique', 'Colombie-Britannique', [genre === feminin]).
lexique(nom, 'Manitoba', 'Manitoba', [genre === masculin]).
lexique(nom, 'Nouveau-Brunswick', 'Nouveau-Brunswick', [genre === masculin]).
lexique(nom, 'Nouvelle-cosse', 'Nouvelle-cosse', [genre === feminin]).
lexique(nom, 'Ontario', 'Ontario', [genre === masculin]).
lexique(nom, 'Qubec', 'Qubec', [genre === masculin]).
lexique(nom, 'Saskatchewan', 'Saskatchewan', [genre === feminin]).
lexique(nom, 'Terre-Neuve', 'Terre-Neuve',[genre === feminin, article === absent]).
lexique(nom, 'le-du-Prince-douard', 'le-du-Prince-douard', [genre === feminin]).

lexique(nom,'France','France',[genre===feminin]).
lexique(nom,'Suisse','Suisse',[genre===feminin]).
lexique(nom,'Europe','Europe',[genre===feminin]).
lexique(nom,'Hongrie','Hongrie',[genre===feminin]).
lexique(nom,'Russie','Russie',[genre===feminin]).
lexique(nom,'Canada','Canada',[genre===masculin]).
lexique(nom,'Algrie','Algrie',[genre===feminin]).
lexique(nom,'activit','activit',[genre===feminin]).
lexique(nom,aeroport,'aroport',[genre===masculin]).
lexique(nom,annee,'anne',[genre===feminin]).
lexique(nom,automne,automne,[genre===masculin]).
lexique(nom,avion,avion,[genre===masculin]).
lexique(nom,avril,avril,[genre===masculin]).
lexique(nom,bug,bug,[genre===masculin]).
lexique(nom,'chmage','chmage',[genre===masculin]).
lexique(nom,compagnie,compagnie,[genre===feminin]).
lexique(nom,continent,continent,[genre===masculin]).
lexique(nom,'cte','cte',[genre===feminin]).
lexique(nom,depense,dpense,[genre===feminin]).
lexique(nom,dollar,dollar,[genre===masculin]).
lexique(nom,emploi,emploi,[genre===masculin]).
lexique(nom,'t','t',[genre===masculin]).
lexique(nom,femme,femme,[genre===feminin,id===implicite]).
lexique(nom,gateau,'gteau',[genre===masculin]).
lexique(nom,heure,heure,[genre===feminin]).
lexique(nom,hiver,hiver,[genre===masculin]).
lexique(nom,homme,homme,[genre===masculin,id===implicite]).
lexique(nom,jour,jour,[genre===masculin]).
lexique(nom,liaison,liaison,[genre===feminin]).
lexique(nom,livre,livre,[genre===masculin]).
lexique(nom,mer,mer,[genre===feminin]).
lexique(nom,minute,minute,[genre===feminin]).
lexique(nom,mois,mois,[genre===masculin]).
lexique(nom,moment,moment,[genre===masculin]).
lexique(nom,moyenne,moyenne,[genre===feminin]).
lexique(nom,nation,nation,[genre===feminin]).
lexique(nom,'ocan','ocan',[genre===masculin]).
lexique(nom,pays,pays,[genre===masculin,id===implicite]).
lexique(nom,printemps,printemps,[genre===masculin]).
lexique(nom,profit,profit,[genre===masculin]).
lexique(nom,province,province,[genre===feminin,id===implicite]).
lexique(nom,'racteur','racteur',[genre===masculin]).
lexique(nom,satellite,satellite,[genre===masculin]).
lexique(nom,semaine,semaine,[genre===feminin]).
lexique(nom,temps,temps,[genre===masculin]).
lexique(nom,ville,ville,[genre===feminin,id===implicite]).
lexique(nom,voyant,voyant,[genre===masculin]).
lexique(nom,'YEN','YEN',[genre===masculin,accord_nombre===invariable]).
lexique(nom,'%','\%',[genre===masculin,accord_nombre===invariable]).
lexique(nom,'$','\$',[genre===masculin,accord_nombre===invariable]).

% Articles

lexique(article,le,le,[definition===defini]).
lexique(article,un,un,[definition===indefini]).



% Adjectifs numeraux

lexique(adjectif,1,premier,[cat_adj===numeral,cat_adj_num===ordinal]).
lexique(adjectif,-1,dernier,[cat_adj===numeral,cat_adj_num===ordinal]).
lexique(adjectif,V,A,[cat_adj===numeral,cat_adj_num===ordinal]):-
       A\==1,A\== -1,
       traduire(V,A1),
       finit_par_voyelle(A1),
       retirer_derniere_lettre(A1,A2),
       mon_concat(A2,'ime',A).
lexique(adjectif,V,A,[cat_adj===numeral,cat_adj_num===ordinal]):-
       A\==1,A\== -1,
       traduire(V,A1),
       \+ finit_par_voyelle(A1),
       \+ finit_par_lettre(q,A1),
       mon_concat(A1,'ime',A).
lexique(adjectif,V,A,[cat_adj===numeral,cat_adj_num===ordinal]):-
       A\==1,A\== -1,
       traduire(V,A1),
       \+ finit_par_voyelle(A1),
       finit_par_lettre(q,A1),
       mon_concat(A1,'uime',A).



% Localisateur temporels


% heure ,  "a 8h15"
lexique(loc_temp,horaire(H,M),Locution,[]):-
       trad_loc(horaire,[H,M],Locution).
lexique(loc_temp,M,M,[]).

% Aderbe temporels

lexique(adverbe,_,actuellement, [ancrage===deictique,
                               des_zone_temp===directe,
                               persp_enon===duratif,
			       unite_cadre===indefini]).
lexique(adverbe,_,maintenant,   [ancrage===deictique,
                               des_zone_temp===directe,
                               persp_enon===ponctuel,
			       unite_cadre===indefini]).

lexique(adverbe,_,'la veille', [ancrage===anaphorique,
                              des_zone_temp===relationnelle,
                              unite_cadre===jour,
			      val_dec===1,
			      type_relation===anteriorite]).

lexique(adverbe,_,'le lendemain',[ancrage===anaphorique,
                                des_zone_temp===relationnelle,
                                unite_cadre===jour,
				val_dec===unitaire,
			        type_relation===posteriorite]).

lexique(adverbe,_,hier,       [ancrage===deictique,
                             des_zone_temp===relationnelle,
                             unite_cadre===jour,
			     val_dec===1,
			     type_relation===anteriorite]).


lexique(adverbe,_,'aujourd''hui', [ancrage===deictique,
	                        des_zone_temp===directe,
                                unite_cadre===jour]).

lexique(adverbe,_,demain,     [ancrage===deictique,
                             des_zone_temp===relationnelle,
                             unite_cadre===jour,
			     val_dec===1,
			     type_relation===posteriorite]).

lexique(adverbe,_,auparavant, [ancrage===anaphorique,
                             des_zone_temp===relationnelle,
                             unite_cadre===_,
			     id_decalage===indefini,
			     type_relation===anteriorite]).

lexique(adverbe,_,puis,       [ancrage===anaphorique,
                             des_zone_temp===relationnelle,
                             unite_cadre===_,
			     id_decalage===indefini,
			     type_relation===posteriorite]).





lexique(adverbe,beaucoup,beaucoup,[]).



% Prepositions temporelles



lexique(preposition,_,'',[des_zone_temp===directe,
                           unite_cadre===indefini,
                           ancrage===anaphorique
                           ]).

lexique(preposition,_,'',[des_zone_temp===directe,
                           unite_cadre===U,
                           ancrage===autonome
                           ]):-
       member(U,[heure,jour,minute,saison]).

lexique(preposition,_,en,[des_zone_temp===directe,
                           unite_cadre===U,
                           ancrage===autonome
                           ]) :-
	member(U,[annee,mois]).

lexique(preposition,_,[],[des_zone_temp===directe,
                           ancrage===A,
                         unite_cadre===U]):-
	member(U,[jour,semaine,mois,annee]),
        member(A,[anaphorique,deictique]).



lexique(preposition(temporelle),_,[],
                     [niveau_loc===secondaire,
                      ancrage===deictique,
                      val_dec===_]).

lexique(preposition(temporelle),_, 'il y a', 
                     [ancrage===deictique,
                      type_relation===anteriorite]).

lexique(preposition(temporelle),_,  dans, 
                     [ancrage===deictique,
                      type_relation===posteriorite]).

lexique(preposition(temporelle),_,  avant, 
                     [ancrage===A,
                      type_relation===anteriorite]):-
       member(A,[anaphorique,autonome]).

lexique(preposition(temporelle),_, 'aprs', 
                     [ancrage===autonome,
                      type_relation===posteriorite]).

lexique(preposition(temporelle),_, 'plus tard', 
                     [ancrage===anaphorique,
                      type_relation===posteriorite]).



%lexique(preposition(temporelle),_,  'avant que', [ancrage===autonome,
%        type_relation===anteriorite,zone_de_reference===occurrence]).
%
%lexique(preposition(temporelle),_, 'aprs que', [ancrage===autonome,
%        type_relation===posteriorite,zone_de_reference===occurrence]).

lexique(preposition(temporelle),_,  pendant, 
                     [aspect_loc===duratif, 
                      type_duree===quantifiee]).

lexique(preposition(temporelle),_,  depuis,  
                     [aspect_loc===duratif, 
                      type_duree===bornee,
	              ancrage_duree===ante,
                      persp_duree===interne
                      ]).

lexique(preposition(temporelle),_,  ' partir de',  
                     [aspect_loc===duratif, 
                      type_duree===bornee,
	              ancrage_duree===ante,
                      persp_duree===externe]).

lexique(preposition(temporelle),_,  'pendant encore', 
                     [aspect_loc===duratif,
                       type_duree===quantifiee]).

lexique(preposition(temporelle),_,  jusque,  
                     [aspect_loc===duratif, 
                      type_duree===bornee,
                      ancrage_duree===post]).

