:-dynamic compteur/1.

:- use_module(library(lists)).
:- use_module(library(basics)).
:- use_module(library(strings)).
:- use_module(library(date)).

divent(X,Y,Z):- Z is X div Y.

eliminer(X,A):- functor(F,X,A),
                otetout(F).

otetout(F):-  retract(F),
	      fail.
otetout(_).

argument(N,F,R) :-
	arg(N,F,R).



% Pour la generation d'un nouveau terme

new_term(Prefixe,X):-
    gensym(Y),
    concatener(Prefixe,'#',P1),
    concatener(P1,Y,X).





nth(X,Y,Z):-nth1(X,Y,Z).


% L'INSTANT D'ENONCIATION

enonciation(E):-enonciation(jour,E).

% Instant d'enonciation donne en jours
enonciation(jour,jour1(J1)):-
  date(date(A,M,J)),
  M1 is M+1,
  A1 is A+1900,
  date_a_jours(J/M1/A1,J1).


% Instant d'enonciation donne en heures
enonciation(heure,heure1(Heures)):-
  date(date(A,M,J)),
  M1 is M+1,
  A1 is A+1900,
  date_a_jours(J/M1/A1,J1),
  time(time(H,Min,_)),
  Heures is ((J1-1)*24 + H+1).


% Instant d'enonciation donne en minutes
enonciation(minute,minute1(Minutes)):-
  date(date(A,M,J)),
  M1 is M+1,
  A1 is A+1900,
  date_a_jours(J/M1/A1,J1),
  time(time(H,Min,_)),
  Minutes is (J1*24 + H)*60+Min.

