
divent(X,Y,Z):- Z is X // Y.

gensym(Id) :-
	gensym('%',Id).

eliminer(X,A):- functor(F,X,A),
                otetout(F).

otetout(F):-  retract(F),
	      fail.
otetout(_).

member(X,[X|_]).
member(X,[_|Reste]):- member(X,Reste).

append([],X,X).
append([X|Xs],Y,[X|Zs]):- append(Xs,Y,Zs).

argument(N,F,R) :-
	functor(F,_,NA),
	NA > 0,
	arg(N,F,R).



enonciation(E):-enonciation(jour,E).

% Instant d'enonciation donne en jours
enonciation(jour,jour1(J1)):-
  date(date(A,M,J)),
  M1 is M+1,
  date_a_jours(J/M1/A,J1).


% Instant d'enonciation donne en heures
enonciation(heure,heure1(Heures)):-
  date(date(A,M,J)),
  M1 is M+1,
  date_a_jours(J/M1/A,J1),
  date(time(H,Min,_)),
  Heures is ((J1-1)*24 + H+1).


% Instant d'enonciation donne en minutes
enonciation(minute,minute1(Minutes)):-
  date(date(A,M,J)),
  M1 is M+1,
  date_a_jours(J/M1/A,J1),
  date(time(H,Min,_)),
  Minutes is (J1*24 + H)*60+Min.


date(date(A,M,J)):-
  get_time(Time),
  convert_time(Time,A,M,J,_,_,_,_).

date(time(H,M,S)):- 
  get_time(Time),
  convert_time(Time,_,_,_,H,M,S,_).



% Pour la generation d'un nouveau terme

new_term(Prefixe,X):-
  concat(Prefixe,'#',P2),
  gensym(P2,X).
