% Pour nommer un instant sans remonter dans tous les cadres
% englobants
nommer2(I,ListeRef,Assoc,Cont):-
    noms_possibles2(I,ListeRef,Assoc,Aout,Cont,N),!,
    retirer_fct(N,Noms),!,
    lister_noms(Noms),
    nl,write(Aout),nl. 

% Pour nommer un instant (version qui imprime)
nommer(I,ListeRef,Assoc,Cont):-
    noms_possibles(I,ListeRef,Assoc,Aout,Cont,N),
    retirer_fct(N,Noms),!,
    nl,write('Contexte initial:'),nl,write(Cont),nl,nl,
    nl,write('Liste des associations:'),nl,write(Aout),nl,nl,
    lister_noms_et_cont(Noms,Cont,Aout).


lister_noms([]).
lister_noms([(C,N,F)|Reste]):-
    write('Cadre: '),write(C),nl,
    write('Nom: '),write(N),nl,
    write('Fonction: '),write(F),nl,nl,
    lister_noms(Reste).
lister_noms([N|Reste]):-
    prettyprint(N),nl,
    lister_noms(Reste).


lister_noms_et_cont([],_,_).
lister_noms_et_cont([N|Reste],C,A):-
    prettyprint(N),nl,
    update_cont_avec_exp(N,A,_,C,Cout),
    write('Nouveau contexte:'),nl,write(Cout),nl,nl,
    lister_noms_et_cont(Reste,C,A).
    




% Pour nommer un insant 
% (version qui retourne la liste des noms possibles)
noms_possibles(somme(S),_,Ain,Aout,_,[[Dref,somme,S,nil]]):-
    binding(Dref,somme(S),Ain,Aout),!.
noms_possibles(ere1(1),_,Ain,Aout,_,[[Dref,ere,global,nil]]):-
    binding(Dref,ere1(1),Ain,Aout),!.
noms_possibles(I,ListeRef,Ain,Aout,Contexte,Nomsfiltres):-
    cadres_imm_englobants(I,Cengl,[]),
    binding(Dref,I,Ain,A1),
    type(I,Type),
    np1(Cengl,I,Dref,Type,N1),
    np2(ListeRef,I,N2,A1,A2),
    mon_merge([N1,N2],N3),
    filtrer_noms(N3,A2,N4),
    poursuivre_denomination(N4,ListeRef,[],A2,Aout,Contexte,N5),
    filtrer_noms(N5,Aout,Nomsfiltres).

% Pour nommer un instant sans remonter dans tous les cadres
% englobants
noms_possibles2(ere1(1),_,A,A,_,[[t,ere,global]]).
noms_possibles2(somme(X),_,A,A,_,[[t,somme,X]]).
noms_possibles2(I,ListeRef,Ain,Aout,_,Nomsfiltres):-
    cadres_imm_englobants(I,Cengl,[]),
    binding(Dref,I,Ain,A1),
    type(I,Type),
    np1(Cengl,I,Dref,Type,N1),
    np2(ListeRef,I,N2,A1,Aout),
    mon_merge([N1,N2],N3),
    filtrer_noms(N3,Aout,Nomsfiltres).


% Detemine si la reference d'un cadre fait partie du contexte
ref_dans_contexte(Cont,C):-
    iref(C,Ref),
    member(_<==>Ref,Cont).


% Pour chaque cadre de la liste on considere toutes les fonctions
% de denomination qui peuvent lui etre associee. On retourne ainsi
% tous les noms obtenus avec ces fonctions
np1([],_,_,_,[]).
np1([C|Cadres],I,Dref,Type,Noms):-
    findall((C,F),fass(C,F),CadFct),
    id_avec_fct_uncadre(CadFct,I,Dref,Type,N1),
    np1(Cadres,I,Dref,Type,N2),
    append(N1,N2,Noms).


id_avec_fct_uncadre([],_,_,_,[]).
id_avec_fct_uncadre([(C,F)|Reste],I,Dref,Type,
                     [incldans([Dref,Type,N,F],temps(Ref))|Ns]):-
    iref(C,Ref),
    appf(gen,F,I,C,N,_),
    id_avec_fct_uncadre(Reste,I,Dref,Type,Ns).

	

% On cherche a nommer en relation avec les temps qui sont dans 
% la liste des references donnee en input
np2(ListeRef,I,Noms,Ain,Aout):-
    id_avec_ref_inclus(ListeRef,I,Ain,A1,N1),
    id_avec_ref_posrel(ListeRef,I,A1,Aout,N2),
    mon_merge([N1,N2],Noms).


% Pour chaque element de la liste de references on verifie
% si le temps a nommer l'inclut. Si c'est le cas on construit
% la forme incl([t,Type,Nom],[Tref,_,_])
id_avec_ref_inclus([],_,A,A,[]).
id_avec_ref_inclus([UneRef|ListeRef],I,Ain,Aout,
            [incl([t,Type,_,nil],[UneRef,_,_,nil])|Noms]):-
    binding(UneRef,Tref,Ain,A1),
    projection(Tref,_,I,[]),
    type(I,Type),
    id_avec_ref_inclus(ListeRef,I,A1,Aout,Noms).
id_avec_ref_inclus([_|ListeRef],I,Ain,Aout,Noms):-
    id_avec_ref_inclus(ListeRef,I,Ain,Aout,Noms).

% On denomme le temps par sa position relative par rapport
% a chaque temps de la liste de references
id_avec_ref_posrel([],_,A,A,[]).
id_avec_ref_posrel([UneRef|ListeRef],I,Ain,Aout,
            [pos_rel(Val,[RefI,Type,_,nil],L)|Noms]):-
    binding(UneRef,Tref,Ain,A1),
    binding(RefI,I,A1,A2),
    type(I,Type),
    pp_cadre_englobant(I,Tref,cadre(R,Type,Dliste)),
    projection(Tref,cadre(R,Type,Dliste),ProjTref,[]), 
    ieme(Pos1,Dliste,I),
    ieme(Pos2,Dliste,ProjTref),
    Val is Pos1 - Pos2,
    (type(Tref,Type), L=[UneRef,Type,_], A3=A2;
     \+type(Tref,Type), binding(CstR1,ProjTref,A2,A3),
                        L=incl([CstR1,Type,_,_],[UneRef,_,_,_])),
    id_avec_ref_posrel(ListeRef,I,A3,Aout,Noms).
id_avec_ref_posrel([_|ListeRef],I,Assoc,Noms):-
    id_avec_ref_posrel(ListeRef,I,Assoc,Noms).



% On elimine les denominations qui ne sont pas convenables
% Pour celles qui restent, on retire l'argument qui donne le
% nom de la fonction utilisee
filtrer_noms([],_,[]).
filtrer_noms([N|Reste],Assoc,ResteFiltre):-
    nonconvenable(N,Assoc),
    filtrer_noms(Reste,Assoc,ResteFiltre).
filtrer_noms([N|Reste],Assoc,[N|ResteFiltre]):-
    filtrer_noms(Reste,Assoc,ResteFiltre).


% Retire le dernier element dans un denomination (celui qui
% indique la fonction)
retirer_fct([],[]).
retirer_fct([X|Xs],[Y|Ys]):-
    retirer_fct2(X,Y),!,
    retirer_fct(Xs,Ys).

retirer_fct2([R,T,N,_],[R,T,N]).
retirer_fct2(incldans([R,T,N,_],Suite),incldans([R,T,N],Suite2)):-
    retirer_fct2(Suite,Suite2).
retirer_fct2(incl([R,T,N,_],Suite),incl([R,T,N],Suite2)):-
    retirer_fct2(Suite,Suite2).
retirer_fct2(pos_rel(Val,[R,T,N,_],Suite),pos_rel(Val,[R,T,N],Suite2)):-
    retirer_fct2(Suite,Suite2).
retirer_fct2(X,X).




% Selon le contexte, on complete la formule de denomination du
% temps en remontant dans les cadres superieurs. On termine 
% lorsque le referent du cadre englobant est dans le contexte.
poursuivre_denomination([],_,_,A,A,_,[]). 
poursuivre_denomination([X|Reste],ListeRef,DejaTraites,
                        Ain,Aout,Cont,[X|Noms]):-
     (X=incl(_,_); X=pos_rel(_,_,_)),
     poursuivre_denomination(Reste,ListeRef,DejaTraites,Ain,Aout,Cont,Noms).
poursuivre_denomination([incldans(X,temps(R))|Reste],
                         ListeRef,DejaTraites,Ain,Aout,Cont,NomsComplets):-
     member((R,Noms),DejaTraites),
     incl_dans_nom(X,Noms,NouveauxNoms),
     poursuivre_denomination(Reste,ListeRef,DejaTraites,
                             Ain,Aout,Cont,AutresNoms),  
     append(NouveauxNoms,AutresNoms,NomsComplets).
poursuivre_denomination([incldans(X,temps(R))|Reste],
                         ListeRef,DejaTraites,Ain,Aout,Cont,
                         [incldans(X,[T,_,_,nil])|Noms]):-
     member(T<==>R,Cont),
     poursuivre_denomination(Reste,ListeRef,DejaTraites,Ain,Aout,Cont,Noms).   
poursuivre_denomination([incldans(X,temps(R))|Reste],
                         ListeRef,DejaTraites,Ain,Aout,Cont,NomsComplets):-
     noms_possibles(R,ListeRef,Ain,A1,Cont,Noms),
     incl_dans_nom(X,Noms,NouveauxNoms),
     poursuivre_denomination(Reste,ListeRef,[(R,Noms)|DejaTraites],
                             A1,Aout,Cont,AutresNoms),
     append(NouveauxNoms,AutresNoms,NomsComplets).


incl_dans_nom(_,[],[]).
incl_dans_nom(L,[N|Ns],[incldans(L,N)|Xs]):-
     incl_dans_nom(L,Ns,Xs).






% PREDICAT POUR FILTRER LES DENOMINATIONS NON CONVENABLES 


% Le temps est denomme par sa position dans la D-liste
% Il s'agit d'un temps pris dans un cadre qui ne lui est
% pas directement superieur
nonconvenable(incldans([DrefI1,_,_,F],temps(T)),Assoc):-
    binding(DrefI1,I1,Assoc,_),  
    member(F,[f0,f0a,f0b]),
    not_cadre_sup(I1,cadre(T,_,_)).  
nonconvenable(incldans([DrefI1,_,_,F],X),Assoc):-
    id_temps_designe(X,[Dref,_,_,_]),
    binding(Dref,I2,Assoc,_),
    binding(DrefI1,I1,Assoc,_),
    member(F,[f0,f0a,f0b]),
    not_cadre_sup(I1,cadre(I2,_,_)).

not_cadre_sup(jour1(_),cadre(Y,_,_)):-
    (type(Y,annee);
    type(Y,ere)),!.
not_cadre_sup(heure1(_),cadre(Y,_,_)):-
    (type(Y,mois);
    type(Y,saison);
    type(Y,annee);
    type(Y,ere)),!.
not_cadre_sup(X,cadre(Y,_,_)):-
    \+ cadre_sup(X,cadre(Y,_,_),[]).


% Denomination par la position dans la d-liste
% (ordre croissant ou decroissant)
% La valeur de la position est trop eleve
nonconvenable(incldans([_,jour,N,F],temps(T)),_):-
    type(T,Type),
    member(Type,[ere,semaine,annee,saison]),
    member(F,[f0,f0a,f0b]),
    (N > 1; N < -2).    
nonconvenable(incldans([_,jour,N,F],X),_):-
    id_temps_designe(X,[_,Type,_,_]),
    member(Type,[ere,semaine,annee,saison]),
    member(F,[f0,f0a,f0b]),
    (N > 1; N < -2).

% Cas ou on ne permet pas la denomination par la position
nonconvenable(incldans([_,U,N,f0],temps(ere1(1))),_):-
    N>1,
    U\==annee.
nonconvenable(incldans([_,U,N,f0],X),Assoc):-
    N>1,
    id_temps_designe(X,[Dref,_,_,_]),
    binding(Dref,ere1(1),Assoc,_),
    U\==annee.

nonconvenable(incldans([_,_,N,f0a],temps(ere1(1))),_):-
    N>1.
nonconvenable(incldans([_,_,N,f0a],X),Assoc):-
    N>1,
    id_temps_designe(X,[Dref,_,_,_]),
    binding(Dref,ere1(1),Assoc,_).


nonconvenable(incldans([_,_,N,f0b],temps(ere1(1))),_):-
    N< -1.
nonconvenable(incldans([_,_,N,f0b],X),Assoc):-
    N< -1,
    id_temps_designe(X,[Dref,_,_,_]),
    binding(Dref,ere1(1),Assoc,_).

nonconvenable(incldans([_,_,_,F],temps(ere1(1))),_):-
    member(F,[f0a,f0b]).
nonconvenable(incldans([_,_,_,F],X),Assoc):-
    id_temps_designe(X,[Dref,_,_,_]),
    binding(Dref,ere1(1),Assoc,_),
    member(F,[f0a,f0b]).

% Si c'est un jour du mois on limite la grandeur du decalage
% pour la forme le Xeme jour avant la fin du mois
% On ne garde que "dernier" et "avant-dernier"
nonconvenable(incldans([_,jour,N,f0b],temps(T)),_):-
   type(T,mois),
   N < -2.
nonconvenable(incldans([_,jour,N,f0b],X),_):-
    id_temps_designe(X,[_,mois,_,_]),
    N < -2.
        
% On elimine le positionnement relatif si egal a zero
nonconvenable(pos_rel(0,_,_),_). 




% On utilise une expression de plusieurs instants a utiliser pour modifier 
% le  contexte


update_cont_avec_exp(Exp,AssocIn,AssocOut,ContIn,ContOut):-
   empiler_les_temps(Exp,AssocIn,[],[T|Temps]),
   update_cont(T,ContIn,ContInter,AssocIn,AssocOut),
   ajouter_temps_contexte(Temps,ContInter,ContOut).



empiler_les_temps([X,_,_],Assoc,In,[X<==>T|In]):-
   binding(X,T,Assoc,_).
empiler_les_temps(Exp,Assoc,In,[X<==>T|In]):-
   functor(Exp,Rel,_),
   member(Rel,[pos_rel,incl,termpar,debpar,entre,etendue]),
   id_temps_designe(Exp,[X,_,_]),
   binding(X,T,Assoc,_).
empiler_les_temps(Exp,Assoc,In,Out):-
   functor(Exp,Rel,_),
   member(Rel,[incldans,deb,term]),
   id_temps_designe(Exp,[X,_,_]),
   id_temps_ref(Exp,Tref),
   binding(X,T,Assoc,_),
   empiler_les_temps(Tref,Assoc,[X<==>T|In],Out).   

ajouter_temps_contexte([],C,C).
ajouter_temps_contexte([T|Reste],Cin,Cout):-
   ajouter_temps_contexte(Reste,[T|Cin],Cout).
