

% DEDUCTION DES RELATIONS TEMPORELLES ENTRE LES TEMPS


% Raisonnement sur la relation d'anteriorite



% Cas simple ou les deux temps sont du meme type
% Ils sont donc dans la meme liste abregee
avant(T1,T2):-
    type(T1,U),
    type(T2,U),!,
    position(T1,P1),
    position(T2,P2),
    P1 < P2.
% Cas ou on doit raisonner en projetant dans un cadre
% superieur
%avant(T1,T2):-
%    cadres_englobants(T1,C1,[]),
%    cadres_englobants(T2,C2,[]),
%    member((cadre(R,U,L),Proj1),C1),
%    member((cadre(R,U,L),Proj2),C2),
%    ieme(I1,L,Proj1),
%    ieme(I2,L,Proj2),
%    I1 < I2.
% Cas ou on raisonne en reecrivant avec une unite inferieure
avant(T1,T2):-
    type(T2,U),
    def_cadre(_,cadre(T1,U,D1)),
    dernier(D1,Der),
    avant(Der,T2).
avant(T1,T2):-
    type(T1,U),
    def_cadre(_,cadre(T2,U,D2)),
    premier(D2,Prem),
    avant(T1,Prem).
avant(T1,T2):-
    def_cadre(_,cadre(T1,_,D1)),
    def_cadre(_,cadre(T2,_,D2)),
    dernier(D1,Der),
    premier(D2,Prem),
    avant(Der,Prem).



% Relation d'anteriorite avec metrique


% Cas simple ou les deux temps sont du meme type
% Ils sont donc dans la meme liste abregee
avant([Val,U],T1,T2):-
    type(T1,U),
    type(T2,U),!,
    position(T1,P1),
    position(T2,P2),
    P1 < P2,
    Val is P2-P1,!.
% Dans les autres cas on ne peut pas identifier une metrique
avant(indefini,_,_).


% Relation d'inclusion de T1 dans T2

% Cas ou la relation est deduite directement
inclus(T1,T2):-
    les_unites(Lu),
    member(U,Lu),
    def_cadre(_,cadre(T2,U,L2)),
    element(T1,L2),!.
% Cas ou la relation est deduite indirectement
inclus(T1,T2):-
    les_unites(Lu),
    member(U,Lu),
    def_cadre(_,cadre(T1,U,L1)),
    def_cadre(_,cadre(T2,U,L2)),
    sousliste(L1,L2).
   



% La propriete d'inclusion carre de cadres
% Les deux cadres doivent avoir le meme type

% Cas ou la reference du cadre inclus est dans la D-liste de
% l'autre cadre
cadinclus(cadre(R,_,_),cadre(_,_,L)):-
    element(R,L),!.


