:-dynamic def_cadre/2.




% Structure temporelle pour les deux millenaires de notre ere

% LES UNITES UTILISEES DANS LES CADRES

les_unites([millenaire,saison,siecle,decennie,annee,mois,jour,semaine,
        momentjournee,journuit,heure,minute]).


% LISTE D'ASSOCIATION ENTRE CADRES ET FONCTIONS DE DESIGNATION



fass(cadre(_,U,_),f0):-
    \+ member(U,[heure,minute]).
fass(_,f0b).
fass(cadre(ere1(_),saison,_),f2).
fass(cadre(ere1(_),journuit,_),f5).
%fass(cadre(ere1(_),jour,_),f7).
%fass(cadre(_,X,_),f8):-
%     member(X,[jour,semaine,mois,annee,saison]).
%fass(cadre(ere1(_),X,_),f9):-
%     member(X,[jour,mois,annee,saison]).
fass(cadre(annee1(_),jour,_),f3).
fass(cadre(annee1(_),mois,_),f4).
fass(cadre(jour1(_),momentjournee,_),f6).
fass(cadre(semaine1(_),jour,_),f1).
fass(cadre(jour1(_),heure,_),f0a).
fass(cadre(heure1(_),minute,_),f0a).



% DECLARATIONS DES LISTES UTILISEES DANS LES CADRES
% Est indique le nom de la liste et le nombre d'elements qu'elle 
% contient ainsi que le type

liste(ere1,1,ere).
liste(millenaire1,2,millenaire).
liste(siecle1,20,siecle).
liste(decennie1,200,decennie).
liste(annee1,2000,annee).
liste(mois1,24000,mois).
liste(semaine1,104355,semaine).
liste(jour1,730485,jour).
liste(journuit1,1460971,journuit).
liste(saison1,8001,saison).
liste(mj1,2921940,momentjournee).
liste(heure1,17531640,heure).
liste(minute1,1051898400,minute).




% Definition des cadres

%def_cadre(1,cadre(ere1(1),millenaire,millenaire1(1,2))).


def_cadre(1,cadre(ere1(1),annee,annee1(1,2000))).

def_cadre(1,cadre(ere1(1),saison,saison1(1,8001))).

def_cadre(1,cadre(ere1(1),semaine,semaine1(1,104355))).

def_cadre(1,cadre(ere1(1),journuit,journuit1(1,1460971))).

def_cadre(1,cadre(ere1(1),jour,jour1(1,730485))).





% Pour conserver la structure de treillis, on attache les cadres
% zone_enon a l'ere
%def_cadre(1,cadre(ere1(1),zones,[pre_enon(X),zone_enon(X),post_enon(X)])).


def_cadre(1,cadre(saison1(1),jour,jour1(1,79))).
def_cadre(1,cadre(saison1(X),jour,jour1(D,F))):-
    liste(saison1,Card,saison),
    element(entier(X),entier(2,Card)),
    appf(gen,f2,saison1(X),jour1(D,F),S,_),
    A is (X-1)//4+1,
    (S = hiver, A1 is A-1, date_a_jours(21/12/A1,D), date_a_jours(20/3/A,F);
     S = printemps, date_a_jours(21/3/A,D), date_a_jours(20/6/A,F); 
     S = ete, date_a_jours(21/6/A,D), date_a_jours(20/9/A,F); 
     S = automne, date_a_jours(21/9/A,D), date_a_jours(20/12/A,F)).    

%def_cadre(1,cadre(millenaire1(X),siecle,siecle1(D,F))):-
%    D is (X-1)*10+1,
%    F is D+9.
%
%
%def_cadre(1,cadre(siecle1(X),decennie,decennie1(D,F))):-
%    \+ var(X),
%    D is (X-1)*10+1,
%    F is D+9.
%
%def_cadre(1,cadre(decennie1(X),annee,annee1(D,F))):-
%    D is (X-1)*10,
%    F is D+9.

def_cadre(1,cadre(annee1(X),mois,mois1(D,F))):-
    D is (X-1)*12+1,
    F is D+11.

%def_cadre(1,cadre(annee1(X),jour,jour1(D,F))):-
%    date_a_jours(1/1/X,D),
%    date_a_jours(31/12/X,F).

def_cadre(1,cadre(mois1(X),jour,jour1(D,F))):-
    mois_a_jours(X,D),
    X1 is X+1,
    mois_a_jours(X1,F1),
    F is F1-1.


def_cadre(1,cadre(semaine1(X),jour,jour1(D,F))):-
    liste(semaine1,Card,semaine),
    element(entier(X),entier(1,Card)),
    D is (X-1)*7+1,
    F is D+6.

def_cadre(1,cadre(jour1(X),momentjournee,mj1(D,F))):-
    D is (X-1)*4+1,
    F is D+3.    

def_cadre(1,cadre(mj1(X),heure,heure1(D,F))):-
    D is (X-1)*6+1,
    F is D+5.

def_cadre(1,cadre(heure1(X),minute,minute1(D,F))):-
    D is (X-1)*60+1,
    F is D+59.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%% LES PROPRIETES %%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Construction de cadre par sommation
% Le cadre a deja ete explicite 
% (il est donc dans la base dynamique)
def_cadre(1,cadre(somme(I),U,L)):-
    cadre_somm(I,U,L),!.
% Sinon
def_cadre(1,cadre(somme(I),U,L)):-
    nonvar(L),
    new_term(i,I),
    assert(cadre_somm(I,U,L)).
   


def_cadre(1,cadre(R,partage(U,X),L1)):-
    cadre_partage(R,U,X,L1),!.
def_cadre(1,cadre(R,partage(U,X),[somme(S)|List])):-
    nonvar(S),
    def_cadre(1,cadre(somme(S),U,_)),
    new_term(p,X),
    assert(cadre_partage(R,U,X,[somme(S)|List])).
    
    
    

% La propriete de transitivite
% Cas ou on ne connait pas l'unite intermediaire
def_cadre(3,cadre(R,U,L)):-
    \+ var(U),
    def_cadre(1,cadre(R,U2,L2)),
    U2 \== U,
    mergeframes(L2,U,L),!.


% Mergeframe 
% Soit une liste d'instant L et U une unite.
% Pour chaque instant I de cette liste, on identifie le cadre
% <I,U,Dlist> et on retourne comme resulation la fusion ce 
% toutes ces Dlist
% Les cas ou la forme abregee de liste est utilisee
mergeframes(L,U,Lout):-
    \+ listestandard(L),
    premier(L,P),
    dernier(L,D),
    def_cadre(_,cadre(P,U,L1)),
    def_cadre(_,cadre(D,U,L2)),!,
    %Tous les elements des sous-listes sont de la meme liste globale 
    (mergef(L1,L2,Lout);
    expand(L,Lexp),
    %on se ramene au cas general
    mergeframes(Lexp,U,Lout)),!.
mergef(L1,L2,Lout):-
   listeabregee(L1),
    listeabregee(L2),
    nomliste(L1,Nom),
    nomliste(L2,Nom),
    premier(L1,L1p),
    dernier(L2,L2d),
    fill_labregee(L1p,L2d,Lout).  
% Le cas general
mergeframes([],_,[]).
mergeframes([X|Xs],U,Lz):-
    def_cadre(_,cadre(X,U,L)),!,
    mergeframes(Xs,U,Ls),
    concat_liste(L,Ls,Lz).




% Recherche dans la liste des definition de cadre le premier 
% dont le no d'identification n'est pas dans la liste donnee
% (Les nos d'identification servent entre autre a eviter
%  les bouclages)

cherche_cadre(ListeNo,C):-
  clause(def_cadre(No,C),_),
  \+ member(No,ListeNo),
  def_cadre(No,C).



% Extraction de l'information relative a un cadre

% L'instant de reference
iref(cadre(R,_,_),R).
% L'unite
unitecadre(cadre(_,U,_),U).
% La liste de decomposition
ldecomp(cadre(_,_,L),L).




% Identifie le cadre le plus petit qui englobe deux temps
pp_cadre_englobant(T1,T2,cadre(T1,Type,Dliste)):-
    T1=ere1(1),
    T1 \== T2,
    projection(T2,cadre(T1,_,_),_,[]),
    type(T2,Type),
    def_cadre(_,cadre(T1,Type,Dliste)),!.
pp_cadre_englobant(T1,T2,cadre(T2,Type,Dliste)):-
    T2=ere1(1),
    T1 \== T2,
    projection(T1,cadre(T2,_,_),_,[]),
    type(T1,Type),
    def_cadre(_,cadre(T2,Type,Dliste)),!.
pp_cadre_englobant(T,T,C):-
    cadres_imm_englobants(T,Cengl,[]),
    trier_cadres(Cengl,[C|_]),!.
pp_cadre_englobant(T,T2,C):-
    projection(T2,cadre(T,_,_),_,[]),
    cadres_imm_englobants(T,Cengl,[]),
    trier_cadres(Cengl,[C|_]),!.
pp_cadre_englobant(T1,T,C):-
    projection(T1,cadre(T,_,_),_,[]),
    cadres_imm_englobants(T,Cengl,[]),
    trier_cadres(Cengl,[C|_]),!.
% Cas general ou les deux temps doivent etre projetes dans 
% un autre cadre
pp_cadre_englobant(T1,T2,cadre(PPM,Type,Dliste)):-
    chercher_maj1(ere1(1),T1,T2,Maj),
    dernier(Maj,PPM),
    def_cadre(_,cadre(PPM,Type,Dliste)).


% Si les deux temps se projettent dans deux elements differents
% du cadre, la Tref de celui-ci est le pp majorant
chercher_maj1(Tref,T1,T2,[Tref|Majorants]):-
    projection(T1,cadre(Tref,_,_),P1,[]),
    projection(T2,cadre(Tref,_,_),P2,[]),
    P1 \== P2,!,
    (findall(M,chercher_maj2(Tref,T1,T2,M),M2),mon_merge(M2,Majorants),!; 
       Majorants=[]).
chercher_maj1(Tref,T1,T2,[Tref|Majorants]):-
    projection(T1,cadre(Tref,_,_),P,[]),
    projection(T2,cadre(Tref,_,_),P,[]),
    chercher_maj1(P,T1,T2,Majorants).


% Si les deux se projettent dans le meme element du cadre
 % Poursuivre la recherche avec cet element
chercher_maj2(Tref,T1,T2,Majorants):-
    projection(T1,cadre(Tref,_,_),P,[]),
    projection(T2,cadre(Tref,_,_),P,[]),
    chercher_maj1(P,T1,T2,Majorants).

    


% Identifie tous les cadres dans lequel est englobe un instant donne.

% Premiere methode:
% On donne tous les cadres, meme ceux qui ne l'englobe pas directement.
% Les cadres qui n'englobent pas directement ne sont pas dans l'unite
% du temps I
cadres_englobants(I,C2,Exclus):-
    les_cadres_engl([I],[],C,Exclus),
    elim_redond(C,C2),!.
% Deuxieme methode:
% On ne donne que ceux qui l'englobe directement
cadres_imm_englobants(I,C3,Exclus):-
    les_cadres_engl([I],[],C,Exclus),
    elim_ref_redond(C,C1),
    elim_proj(C1,C2),
    type(I,T),
    ramener_au_type(T,C2,C3),!.



% Deux methodes:
% La premiere utilise la propriete de transitivite, ce qui donne 
% un plus grand nombre de cadres.
les_cadres_engl([],L,L,_).
les_cadres_engl([I|Reste],Lin,Lout,Exclus):-
    findall(X,cadre_sup(I,X,Exclus),L),
    extraire_refs(L,Inst),
    append(Inst,Reste,Reste2),
    pointer_inst(I,L,L0),
    append(Lin,L0,L1),
    les_cadres_engl(Reste2,L1,Lout,Exclus).

% Extrait, pour chaque cadre d'une liste, l'instant de reference
% qui y correspond
extraire_refs([],[]).
extraire_refs([cadre(R,_,_)|Cs],[R|Is]):-
    extraire_refs(Cs,Is).
    
% Remplace chaque cadre de la liste par une paire comprenant 
% ca cadre et le temps dont on cherche les englobants
pointer_inst(_,[],[]).
pointer_inst(I,[C|Cs],[(C,I)|Cs2]):-
    pointer_inst(I,Cs,Cs2).



% Elimine dans une liste de cadre les occurrences multiples
% de cadre ayant la meme reference
elim_ref_redond([],[]).
elim_ref_redond([(cadre(R,_,_),_)|Cs],Cs2):-
    member((cadre(R,_,_),_),Cs),
    elim_ref_redond(Cs,Cs2).
elim_ref_redond([C|Cs],[C|Cs2]):-
    elim_ref_redond(Cs,Cs2).

    

% Prend un type et une liste de cadres
% Pour chacun des cadres, on essaie de le reecrire en termes du 
% type donne. La propriete de transitivite peut etre utilisee.

% Si un cadre ne peut etre reecrit dans le type donne, il est 
% elimine de la liste.

ramener_au_type(_,[],[]).
ramener_au_type(T,[cadre(R,T,L)|Cs],[cadre(R,T,L)|NCs]):-
   ramener_au_type(T,Cs,NCs).
ramener_au_type(T,[cadre(R,T1,_)|Cs],[cadre(R,T,L2)|NCs]):-
   T \== T1,
   def_cadre(_,cadre(R,T,L2)),
   ramener_au_type(T,Cs,NCs).
ramener_au_type(T,[_|Cs],NCs):-
   ramener_au_type(T,Cs,NCs).


% Eliminer dans la liste des cadres englobants, l'element de 
% la paire qui correspond a la projection
elim_proj([],[]).
elim_proj([(C,P)|R1],[C|R2]):-
   elim_proj(R1,R2).


% Pour trouver la projection d'un temps dans un cadre
% C est le cadre dans lequel on projete
% P est l'element du cadre dans lequel l'instant se projete
% L'argument Exclus est un index indiquant la classe
% de cadres qui ne doit pas etre pris en compte dans la recherche.

   
% Cas ou la forme de C est totalement inconnue
projection(T,C,P,Exclus):-
   cadres_englobants(T,Cengl,Exclus),
   member((C,P),Cengl).
projection(T,cadre(R,U,L),T,Exclus):-
   cadres_imm_englobants(T,CadImmEngl,Exclus),
   member(cadre(R,U,L),CadImmEngl),
   element(T,L),!.
projection(T,cadre(R,U,L),P,Exclus):-
   nonvar(R),
   cadres_englobants(T,Cengl,Exclus),
   member((cadre(R2,U,_),P),Cengl),
   projection(R2,cadre(R,_,_),_,Exclus).




% Pour trouver un cadre immediatement englobant d'un instant
% sans utiliser la propritete de transitivite
cadre_sup(I,cadre(R,U,L),Exclus):-
    type(I,U),
    clause(def_cadre(N,cadre(R,U,L)),_),
    \+ member(N,[3]),   % Pour eviter l'application de la regle
                        % de transitivite
    \+ member(N,Exclus),
    det_rech(I,R,U,L).

% R est un element non identifie d'une liste abregee
det_rech(I,R,U,L):-
     nomliste(R,Nom),
     position(R,Pos),
     var(Pos), 
     liste(Nom,Card,_),
     % L est sous forme abregee on peut faire une rech binaire
     (listeabregee(L),
     rech_bin_cadre_sup(Nom,U,1,Card,I,cadre(R,U,L));
     % Sinon recherche exhaustive
     rech_exhaust_cadre_sup(Nom,U,1,Card,I,cadre(R,U,L))),!.

% R est un element identifie
det_rech(I,R,U,L):-
     def_cadre(_,cadre(R,U,L)), 
     element(I,L).


% Recherche binaire d'un cadre
rech_bin_cadre_sup(Nom,U,X,Y,I,cadre(R,U,L)):-
    X =< Y,
    Z is (X+Y)//2,
    R =.. [Nom,Z],
    def_cadre(_,cadre(R,U,L)),
    element(I,L),!.        
rech_bin_cadre_sup(Nom,U,X,Y,I,C):-
    X =< Y,
    Z is (X+Y)//2,
    R =.. [Nom,Z],
    def_cadre(_,cadre(R,U,L)),
    L =.. [_,Deb,_],
    I =.. [_,No],
    (No < Deb -> Y1 is Z-1,!,rech_bin_cadre_sup(Nom,U,X,Y1,I,C);
                 X1 is Z+1,!,rech_bin_cadre_sup(Nom,U,X1,Y,I,C)).

    



rech_exhaust_cadre_sup(Nom,U,X,Y,I,cadre(R,U,L)):-
    X =< Y,
    R =.. [Nom,X],
    def_cadre(_,cadre(R,U,L)),
    element(I,L),!.
rech_exhaust_cadre_sup(Nom,U,X,Y,I,C):-
    X =< Y,
    X1 is X+1,
    rech_exhaust_cadre_sup(Nom,U,X1,Y,I,C).

    

% Trie une liste de cadres en ordre croissant de la taille de 
% leurs D-listes
trier_cadres(Cin,Cout):-
    trier_cadres(Cin,[],Cout).
trier_cadres([],L,L).
trier_cadres([C|Cs],Lin,Lout):-
    inserer_cadre(C,Lin,Linter),
    trier_cadres(Cs,Linter,Lout).

inserer_cadre(C,[],[C]).
inserer_cadre(cadre(R1,U1,L1),[cadre(R2,U2,L2)|Xs],
              [cadre(R1,U1,L1),cadre(R2,U2,L2)|Xs]):-
    longueur(L1,Long1),
    longueur(L2,Long2),
    Long1 < Long2.
inserer_cadre(C1,[C2|Xs],[C2|Ys]):-
    inserer_cadre(C1,Xs,Ys).
   




% Pour effacer la base dynamique

eb:-
   abolish(cadre_somm,3).

