
% Definitions de predicats utilitaire


% Utilitaires sur les listes
% Pour tenir compte de la forme abregee de notation telle que
% L = nom(i,j) est synonyme de L = [nom(i),nom(i+1),...,nom(j)]
% Si c'est deja sous forme de liste on appelle les clauses standard




% OPERATIONS AVEC MODULO

plusmod(X,Y,Mod,Z):-
    X1 is X mod Mod,
    Y1 is Y mod Mod,
    Z is (X1+Y1) mod Mod.
moinsmod(X,Y,Mod,Z):-
    X1 is X mod Mod,
    Y1 is Y mod Mod,
    Z1 is (X1-Y1) mod Mod,
    (Z1 < 0 -> Z is Mod+Z1; Z is Z1).

% VERIFICATION DE LA PARITE D'UN NOMBRE

pair(X):-     0 is X mod 2.
impair(X):-   1 is X mod 2.




% Pour la generation d'un nouveau terme

new_term(Prefixe,X):-
    gensym(Y),
    concatener(Prefixe,'#',P1),
    concatener(P1,Y,X).



% Concatener deux chaines de caracteres
concatener(Chaine1,Chaine2,Res):-
    nom(Chaine1,Ch1),
    nom(Chaine2,Ch2),
    append(Ch1,Ch2,ChRes),
    nom(Res,ChRes).

nom(X,Xl) :-				% explose
    \+ var(X),!, name(X,Codes), nom1(Codes,Xl).
nom(X,Xl) :-				% compose
    \+ var(Xl),!, nom1(Codes,Xl), name(X,Codes).
nom(X,X1) :-
    \+ var(X), \+var(X1),
    nom(X2,X1),
    X == X2.

nom1([],[]).
nom1([X|Xs],[X1|X1s]):- name(X1,[X]), nom1(Xs,X1s).




% Pour effacer la base dynamique

eb:-
   abolish(cadre_somm,3).




prettyprint(X):-pp(0,X),nl,!.



pp(N,temps(X)):-
	tab(N),write(temps(X)).
pp(N,[X,Y,Z]):-
        tab(N),write([X,Y,Z]).
pp(N,Exp):-
	Exp =..[Relation,A,B],
        member(Relation,[incl,incldans]),
        write(Relation),write('('),
        valeur_tab(Relation,Tab),
        N2 is N+Tab,
        pp1(N2,A),write(','),nl,
	pp2(N2,B),write(')').    
pp(N,pos_rel(Val,A,B)):-
        write('pos_rel('),write(Val),write(','),
        name(Val,X),
        length(X,L),
        N2 is N+8+L+1,
        pp1(N2,A),write(','),nl,
	pp2(N2,B),write(')').     

pp1(_,[X,Y,Z]):-
	write([X,Y,Z]).
pp1(N,X):-
        pp(N,X).
        
pp2(N,[X,Y,Z]):-
	tab(N),write([X,Y,Z]).
pp2(N,X):-
	tab(N),pp(N,X).

	

valeur_tab(incl,5).
valeur_tab(incldans,9).

