cr_c([E,R,P,L,C]):-
    assert(temps(enon,E)),
    assert(temps(ref,R)),
    assert(temps(loct,L)),
    assert(temps(persp,P)),
    assert(cadre_temporel(C)).    
init_contexte:-
    assert(temps(enon,n)),
    assert(temps(ref,indefini)),
    assert(temps(loct,indefini)),
%    assert(temps(persp,indefini)),
    constante(n,Zone),
    cherche_cadre_temporel(Zone,Cadre),
    assert(cadre_temporel(Cadre)).

effacer_contexte:-
    retract(temps(enon,_)),
    retract(temps(ref,_)),
    retract(temps(loct,_)),
    retract(temps(persp,_)),
    retract(cadre_temporel(_)).

ecrire_contexte:-
	temps(enon,E),
	temps(ref,R),
	temps(persp,P),
	temps(loct,L),
        cadre_temporel(C),
	write('Reperes (ERPLC):  '),
	write([E,R,P,L,C]),nl.


% Calcule la nouvelle reference. Si on a un evenement, il devient
% la nouvelle reference.
% Si on a Loct inclus dans une situation, Loct devient la nouvelle
% reference
% Sinon elle demeure inchangee.
calcule_repere(ref,Even):-
	even(Even,X),
	member(action(_),X),
	retract(temps(ref,_)),
	assert(temps(ref,Even)).
calcule_repere(ref,Even):-
        even(Even,X),
        (member(situation(_),X);member(resultat(_),X)),
        temps(loct,L),
        prop(_,relation(L,Even),incldans),
	retract(temps(ref,_)),        
        assert(temps(ref,L)).
calcule_repere(ref,_).

% Calcule le point de localisation temporelle. Il s'agit du localisateur
% le plus precis entre l'evenement lui-meme et la constante temporelle qui
% le localise (si celle-ci existe).
% Si les deux sont aussi precis on choisit par defaut l'evenement comme 
% nouvelle reference.
calcule_repere(loct,Even):-
	circonstances(Even,Rel),
	temps(enon,E),
	member(incldans(E,Even),Rel),
	retract(temps(loct,_)),
	assert(temps(loct,E)).
calcule_repere(loct,Even):-
	circonstances(Even,Rel),
	  (member(term(C,Even),Rel); 
	   member(incldans(C,Even),Rel); 
	   member(incl(Even,C),Rel)),
	(nom(C,[c,t|_]);  temps(enon,C)),
	retract(temps(loct,_)),
	assert(temps(loct,C)).
calcule_repere(loct,Even):-
	retract(temps(loct,_)),
	assert(temps(loct,Even)).       


% Calcule le point de perspective. Si le processus est anterieur 
% a la reference, celle-ci devient le point de perspective.

% On conserve la meme perspective
calcule_repere(persp,Even):-
	temps(ref,Ref),
	temps(persp,P),
	circonstances(Even,Rel),
	  (member(avant(Ref,Even),Rel); 
	   member(apres(Even,Ref),Rel)),

	  (member(avant(Even,P),Rel);
	   member(apres(P,Even),Rel)).
calcule_repere(persp,Even):-
	temps(ref,Ref),
	circonstances(Even,Rel),
	  (member(avant(Even,Ref),Rel); 
	   member(apres(Ref,Even),Rel)),
	retract(temps(persp,_)),
	assert(temps(persp,Ref)).
calcule_repere(persp,_):-
	temps(enon,E),
	retract(temps(persp,_)),
	assert(temps(persp,E)).



calcule_cadre(Zone):-
        cherche_cadre_temporel(Zone,Cadre),
        (Cadre \== nil, retract(cadre_temporel(_)),
                        assert(Cadre);
                        true).



% Pour chercher le cadre temporel d'une constante


cherche_cadre_temporel(constante(C),Cad):-
        constante(C,Valeur),
        cherche_cadre_temporel(Valeur,Cad).
cherche_cadre_temporel(position(C,_),cadre_temporel(C)).
% Operateur binaire
cherche_cadre_temporel(Op2,C):-
       	Op2 =.. [Operateur,I|_],
        op_temp(Optemp),
        member(Operateur,Optemp),
        cherche_cadre_temporel(I,C).
% Dans les autres cas, aucun cadre n'est specifie
cherche_cadre_temporel(_,nil).
