tcs(Struct):-
  les_relations(Rel),
  findall(X,constante(X,_),Ctes),
  findall(Y,occurence(Y,_),Occ),
  append(Ctes,Occ,Objets),
  calculer_struct(Rel,Objets,[],Struct).


calculer_struct([O|Objets],Rel,Structin,Structout):-
    ajouter(O,Rel,Structin,StructInterm),
    calculer_struct(Objets,Rel,StructInterm,Structout).

ajouter(Objet,Rel,struct(ListeObj,ListeInst),Structout):-
    trouver_obj_recouv(Rel,Objet,ListeObj,ListeObjRec,ListeObjNonRec),
    recalculer_struct(ListeInst,ListeObjRec,ListeObjNonRec,StructOut).


trouver_obj_recouv(_,_,[],[]).
trouver_obj_recouv(Rel,O1,[O2|ListeObj],[O2|ListeObjRec],ListeObjNonRec):-
    (member(equ(O1,O2),Rel);
    member(equ(O2,O1),Rel);
    member(incldans(O1,O2),Rel);
    member(incldans(O2,O1),Rel);
    member(term(O1,O2),Rel);
    member(term(O2,O1),Rel);
    member(term(O1,O2),Rel);
    member(deb(O2,O1),Rel);
    member(deb(O2,O1),Rel)),
    trouver_obj_recouv(Rel,O1,ListeObj,ListeObjRec,ListeObjNonRec).
trouver_obj_recouv(Rel,O1,[O2|ListeObj],ListeObjRec,[O2|ListeObjNonRec]):-
    (member(avant(O1,O2),Rel);
    member(avant(O2,O1),Rel)),
    trouver_obj_recouv(Rel,O1,ListeObj,ListeObjRec,ListeObjNonRec).    
trouver_obj_recouv(Rel,O,[_|ListeObj],ListeObjRec,ListeObjNonRec):-
    trouver_obj_recouv(Rel,O,ListeObj,ListeObjRec,ListeObjNonRec).



% Determine si deux objets temporels sont simultane
% La fermeture transitive n'est pas prise en compte

simultane(_,X,X).
simultane(ListeRel,X,Y):-
    member(Une_rel,ListeRel),
    (Une_rel =.. [Rel,X,Y];
     Une_rel =.. [Rel,Y,X]),
    rel_de_sim(Rel).

rel_de_sim(equ).
rel_de_sim(incldans).
rel_de_sim(term).
rel_de_sim(deb).
